#!/usr/bin/python
import numpy
from scipy import sparse
from sklearn import decomposition
import copy
import re, itertools, random, glob
import networkx as nx
import matplotlib.pyplot as plt

from experimental import *
from mine_team_size import *
from mine_team_Q import *

import pdb

############################################################
###             ACTIONS
############################################################
def doNothing(graph, nopis, data_parameters):
    return

############## COMPUTE DISTRIBUTIONS
############## for all existing opinions variants
def doHistsA(graph, nopis, data_parameters):
    print data_parameters["basis"]
    # nopis_cf = nopis
    # nopis_kw = readOpisNum(data_parameters['data_rep']+data_parameters["network"]+".kw_opinions")
    # nopis_ur = readOpisNum(data_parameters['data_rep']+data_parameters["network"]+".ur_opinions")

    for i in [1,2,4,6,8,12,14,16,18]:
        if i == 1:
            typ = "ur"
        elif i < 10:
            typ = "t%ir" % i
        else:
            typ = "x%ir" % (i%10)
        if not os.path.isfile(data_parameters['data_rep']+data_parameters["network"]+(".%s_opinions" % typ)):
            continue
        data = readOpisNum(data_parameters['data_rep']+data_parameters["network"]+(".%s_opinions" % typ))
        bins = numpy.arange(0,1.01,0.1)
        binning = [numpy.histogram(data[:,i], bins)[0] for i in range(data.shape[1])]
        out = numpy.vstack([numpy.arange(bins.shape[0]-1), bins[1:]]+binning).T
        ## print "DATA", data.shape, "SUM", out.sum(0)
        numpy.savetxt("../xps_prepared/"+data_parameters["network"].replace("#", "X")+("_%s_hist.ops" % typ), out, "%.2f") #, header="First column sums all others")

        #### hist opinion diffs
        if "mats" in data_parameters:
            tmp = noavg_opd(data, data_parameters["mats"][0])
        else:
            adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
            tmp = noavg_opd(data, adjG)
        data = numpy.hstack([tmp.sum(1).reshape((-1, 1))/tmp.shape[1], tmp])
        bins = numpy.array([0]+[2.**(-i) for i in range(11)][::-1])
        binning = [numpy.histogram(data[:,i], bins)[0] for i in range(data.shape[1])]
        out = numpy.vstack([numpy.arange(bins.shape[0]-1), bins[1:]]+binning).T
        numpy.savetxt("../xps_prepared/"+data_parameters["network"].replace("#", "X")+("_%s_hist.opdiffs" % typ), out, ["%d", "%f"]+ ["%d" for i in range(len(binning))]) #, header="First column sums all others")

############## for the provided opinions (different binning!)
def doHistsB(graph, nopis, data_parameters):

    if numpy.sum(nopis) == 0:
        nopis = readOpisNum(".".join(data_parameters['data_file'].split(".")[:-1]+["%s_opinions" % data_parameters['opityp']]))
    #### hist opinions
    data = numpy.hstack([nopis.sum(1).reshape((-1, 1))/nopis.shape[1], nopis])
    bins = numpy.arange(0,1.01,0.1)
    binning = [numpy.histogram(data[:,i], bins)[0] for i in range(data.shape[1])]
    out = numpy.vstack([numpy.arange(bins.shape[0]-1), bins[1:]]+binning).T
    numpy.savetxt("../xps_prepared/"+data_parameters["network"].replace("#", "X")+"_hist.ops", out, "%.2f") #, header="First column sums all others")

    #### hist opinion diffs
    if "mats" in data_parameters:
        tmp = noavg_opd(nopis, data_parameters["mats"][0])
    else:
        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
        tmp = noavg_opd(nopis, adjG)
    data = numpy.hstack([tmp.sum(1).reshape((-1, 1))/tmp.shape[1], tmp])
    bins = numpy.concatenate((numpy.arange(0,0.0101,0.001), [0.1, 0.5, 1]))
    binning = [numpy.histogram(data[:,i], bins)[0] for i in range(data.shape[1])]
    out = numpy.vstack([numpy.arange(bins.shape[0]-1), bins[1:]]+binning).T
    numpy.savetxt("../xps_prepared/"+data_parameters["network"].replace("#", "X")+"_hist.opdiffs", out, "%.3f") #, header="First column sums all others")
    return

############## PREPARE DATA
def saveAsNum(graph, nopis, data_parameters):
    # bbf = data_parameters['results_rep'] + "_".join(data_parameters['basis'].split("_")[:-1])
    bbf = data_parameters['results_rep'] + data_parameters['basis']
    fe = open(bbf + ".edgelist", "w")
    # fo = open(bbf + "." + data_parameters["oopityp"] + "opinions", "w")
    fm = open(bbf + ".labels", "w")
    ce = 0
    for i, n in enumerate(data_parameters["map_iton"]):
        for ni in graph[i].keys():
            if ni > i:
                ce += 1
                fe.write("%d\t%d\n" % (i, ni))
        fm.write("%d\t%s\n" % (i, n))
        # fo.write(" ".join(map(str,nopis[i]))+"\n")
    # fo.close();
    fm.close(); fe.close()
    # print bbf, data_parameters["oopityp"], len(data_parameters["map_iton"]), ce
    return

############## PREPARE Conferences attributes
def prepareConfs(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    with open(ff.replace(suff, ".nodemap"), 'w') as fi:
        fi.write('\n'.join(data_parameters['map_iton']))

    ## numpy.savetxt(ff.replace(suff, ".nopinions"), data_parameters["nopis"], fmt="%f")

    with open(ff.replace(suff, ".edges"), 'w') as fi:
        for nA, ns  in data_parameters['trans_graph'].items():
            for nB in ns:
                if nA < nB:
                    fi.write('%d %d\n' % (nA, nB))
    authors_map = data_parameters['map_ntoi']

    conf_edges = {}
    with open("/".join(ff.split("/")[:-1]+["comms_lists_counts.txt"])) as fi:
        for line in fi:
            parts = line.strip().split("\t")
            for authn in parts[1].split(";"):
                pp = authn.split(":")
                if pp[0] in authors_map and int(pp[1]) > 3:
                    if parts[0] in conf_edges:
                        conf_edges[parts[0]].append(authors_map[pp[0]])
                    else:
                        conf_edges[parts[0]] = [authors_map[pp[0]]]
    ck = sorted(conf_edges.keys())
    with open(ff.replace(suff, ".confmap"), "w") as fi:
        fi.write("\n".join(ck))

    off_auth = len(authors_map)
    with open(ff.replace(suff, ".confedges"), "w") as fi:
        for ci,c in enumerate(ck):
            fi.write("\n".join(["%d\t%d" % (ci+off_auth, a) for a in conf_edges[c]])+"\n")

            
############## PREPARE Keywords attributes
def prepareKeywords(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    if "map_iton" not in data_parameters:
        with open(ff.replace(suff, ".nodemap")) as fi:
            data_parameters['map_iton'] = [t.strip() for t in fi.readlines()]
    if "map_ntoi" not in data_parameters:
            data_parameters['map_ntoi'] = dict([(v,i) for (i,v) in enumerate(data_parameters['map_iton'])])
    
    lbls_filename = ff.replace(suff, ".labels")

    if not os.path.isfile(lbls_filename.replace(".labels", ".lcounts")):
        counts = {}
        with open(lbls_filename) as fp:
            for line in fp:
                parts = line.strip().split("\t")
                counts[parts[1]] = counts.get(parts[1], 0) +1

        kk = sorted(counts.keys())            
        with open(lbls_filename.replace(".labels", ".lcounts"), "w") as fi:
            fi.write("\n".join(["%s\t%s" % (k, counts[k]) for k in kk]))

    itokw = []
    with open(lbls_filename.replace(".labels", ".lcounts")) as fi:
        for line in fi:
            parts = line.strip().split("\t")
            try:
                if int(parts[1]) > 3:
                    itokw.append(parts[0])
            except ValueError:
                pass
    kwtoi = dict([(v,i) for (i,v) in enumerate(itokw)])
    # with open(ff.replace(suff, ".kwmap"), "w") as fo:
    #     fo.write("\n".join(itokw))

    kept = set()
    off_auth = len(data_parameters['map_ntoi'])
    with open(ff.replace(suff, ".kwedges"), "w") as fo:
        with open(lbls_filename) as fi:
            for line in fi:
                parts = line.strip().split("\t")
                if parts[0] in data_parameters['map_ntoi'] and parts[1] in kwtoi: # and int(parts[2]) > 50:
                    fo.write("%d\t%d\n" % (kwtoi[parts[1]]+off_auth, data_parameters['map_ntoi'][parts[0]]))
                    #kept.add(parts[1])
    # with open(ff.replace(suff, ".kwmap_more"), "w") as fo:
    #     fo.write("\n".join(sorted(kept)))

############## PREPARE Opinions Random
def prepareOpiR(graph, nopis, data_parameters):
    ### UNIFORM RANDOM
    parts = numpy.random.rand(nopis.shape[0], 10)
    numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+".ur_opinions", parts, "%f")
    ur = parts
    
    ### POWER LAW
    for i in [2,4,6,8]:
        parts = 1-numpy.random.power(i, (nopis.shape[0], 10))
        numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+(".x%dr_opinions" % i), parts, "%f")

    # ### THRESHOLD
    idxs = numpy.vstack([numpy.random.permutation(nopis.shape[0]) for d in range(nopis.shape[1])]).T
    for i in [2,4,6,8]:
        parts = ur.copy()
        parts[idxs<(nopis.shape[0]*(i/10.))] = 0.0
        numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+(".t%dr_opinions" % i), parts, "%f")
    return parts

############## PREPARE Opinions based on attributes
def prepareOpiF(graph, nopis, data_parameters):
    ### KEYWORD BASED
    data = numpy.loadtxt(data_parameters["data_rep"]+data_parameters["network"]+".kwedges")
    A = sparse.coo_matrix((numpy.ones(data[:,0].shape), (data[:,1], data[:,0]-(1+data[:,1].max()))))
    tmp = decomposition.TruncatedSVD(n_components=10).fit_transform(A)
    parts = numpy.vstack([(tmp[:,i]-numpy.min(tmp[:,i]))/(numpy.max(tmp[:,i])-numpy.min(tmp[:,i])) for i in range(tmp.shape[1])]).T
    numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+".kw_opinions", parts, "%f")

    ### CONF BASED
    data = numpy.loadtxt(data_parameters["data_rep"]+data_parameters["network"]+".confedges")
    A = sparse.coo_matrix((numpy.ones(data[:,0].shape), (data[:,1], data[:,0]-(nopis.shape[0]))), shape=(nopis.shape[0], (data[:,0]-(nopis.shape[0])).max()+1))
    tmp = decomposition.TruncatedSVD(n_components=10).fit_transform(A)
    parts = numpy.vstack([(tmp[:,i]-numpy.min(tmp[:,i]))/(numpy.max(tmp[:,i])-numpy.min(tmp[:,i])) for i in range(tmp.shape[1])]).T
    numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+".cf_opinions", parts, "%f")
    return parts

    # tmp = decomposition.TruncatedSVD(n_components=nopis.shape[1]-1).fit_transform(nopis)
    # parts = numpy.vstack([(tmp[:,i]-numpy.min(tmp[:,i]))/(numpy.max(tmp[:,i])-numpy.min(tmp[:,i])) for i in range(tmp.shape[1])]).T
    # numpy.savetxt(data_parameters["data_rep"]+data_parameters["network"]+".lopinions", parts, "%f")
    # return parts


############## PREPARE Query sets
############## For the community search, distance binned
def prepareQs(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    K = 6
    S = 1000
    percents = [10, 33, 66, 90]
    G = nx.read_edgelist(ff.replace(suff,".edges"), nodetype=int, data=(('weight',int),))
    lengthD = nx.all_pairs_shortest_path_length(G)
    lengthM = numpy.array([[lengthD[i][j] for j in range(len(G))] for i in range(len(G))])
    nds = G.nodes()
    for lq in set(data_parameters["lqs"]):
        sfilename = ".".join(ff.split(".")[:-1]) + "-%d.Qs" % lq
        iddists = numpy.where(numpy.tril(numpy.ones((lq,lq)),k=-1))
        Qs = []
        stats = []

        # seed = numpy.argmin(numpy.sum(lengthM,1))
        # candidates = numpy.where(lengthM[seed,:]==numpy.max(lengthM[seed,:]))[0]
        for k in range(S):
            Q = numpy.random.choice(nds, lq, replace=False)
            
            # Q = [numpy.random.choice(lengthM.shape[0]), numpy.random.choice(candidates)]
            # while len(Q) < lq+1: 
            #     Q.append(numpy.random.choice(numpy.where(numpy.sum(lengthM[Q,:],0)==numpy.max(numpy.sum(lengthM[Q,:],0)))[0]))
            # Q.pop(0)
            # print Q

            ll = lengthM[Q,:]
            dists = ll[:,Q]
            Qs.append(Q)
            # stats.append([numpy.mean(dists), numpy.median(dists), numpy.max(dists), numpy.min(dists+numpy.max(dists)*(numpy.tril(dists, k=0)== 0))])
            stats.append([numpy.mean(dists), numpy.max(dists)])

        stats = numpy.array(stats)
        #bins = numpy
        idx = zip(*[numpy.digitize(stats[:,k], numpy.unique([numpy.percentile(stats[:,k], p) for p in percents])) for k in range(stats.shape[1])])
        groups = []
        uniquekeys = []
        data = sorted([(v,k) for k,v in enumerate(idx)])
        for k, g in itertools.groupby(data, key= lambda x: x[0]):
            groups.append(list(g))      # Store group iterator as a list
            uniquekeys.append(k)

        with open(sfilename, "w") as fp:
            for gi, group in enumerate(groups):
                group = [x[1] for x in group]
                if len(group) > K:
                    ss = random.sample(group, K)
                else:
                    ss = group
                for s in ss:
                    Q = Qs[s]
                    
                    distsv = lengthM[Q[iddists[0]],Q[iddists[1]]]
                    fp.write( " ".join(map(str,sorted(Q))) +"\t"+
                              " ".join(map(str,uniquekeys[gi])) +"\t" +
                              " ".join(map(str, distsv)) +"\n")
                # samples_ids[uniquekeys[gi]] = ss

        # plt.subplot(1,3,1)
        # plt.plot(radii, mean_d, "+")
        # plt.xlim([min(radii)-1, max(radii)+1])
        # plt.ylim([min(mean_d)-1, max(mean_d)+1])
        # plt.subplot(1,3,2)
        # plt.boxplot(stats)
        # plt.plot(stats.T)
        # plt.show()

############## For the team formation, based on conferences
def prepareQCs(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    G = nx.read_edgelist(ff.replace(suff,".edges"), nodetype=int)
    lengthD = nx.all_pairs_shortest_path_length(G)
    lengthM = numpy.array([[lengthD[i][j] for j in range(len(G))] for i in range(len(G))])

    with open(ff.replace(suff, ".confmap")) as fp:
        conf_names = [line.strip() for line in fp]
                    
    conf_to_auth = {}
    with open(ff.replace(suff, ".confedges")) as fp:
        for line in fp:
            parts = map(int,line.strip().split("\t"))
            if parts[0] in conf_to_auth:
                conf_to_auth[parts[0]].append(parts[1])
            else:
                conf_to_auth[parts[0]] = [parts[1]]

                
    ord_conf = sorted([c for c in conf_to_auth.keys()])
    conf_map = dict([(i, (v, conf_names[i])) for (i,v) in enumerate(ord_conf)])
    ca_dists = numpy.vstack([1+numpy.min(lengthM[conf_to_auth[conf], :], axis=0) for conf in ord_conf])
    cc_dists = numpy.zeros((ca_dists.shape[0], ca_dists.shape[0]), dtype=numpy.int8)
    for i in range(ca_dists.shape[0]):
        for j in range(i):
            cc_dists[i,j] = numpy.min(ca_dists[i,:]+ca_dists[j,:])
            cc_dists[j,i] = cc_dists[i,j]

    graceS = 2
    lmbd = 0.1
    with open(ff.replace(suff, "-C.Qs"), "w") as fqo:
        for thresde, thresdi in [(0,0), (0,2), (5,0), (5,2)]:
	### thresde: min number of authors per conf
	### thresdi: max number of common authors between two confs in the query set
            for k in range(20):
                candidates = set([i for (i, v) in conf_map.items() if len(conf_to_auth[v[0]]) > thresde])
                samp = True
                Q = []
                while len(candidates) > 0 and numpy.random.random() >= (1-numpy.exp(-lmbd * (len(Q)-graceS))):
                    Q.append(numpy.random.choice(list(candidates)))
                    drop = numpy.where(cc_dists[Q[-1], :] <= thresdi)[0]
                    candidates.difference_update(drop)

                lq = len(Q)
                Q.sort()
                Qa = numpy.array(Q)
                iddists = numpy.where(numpy.tril(numpy.ones((lq,lq)),k=-1))

                distsv = cc_dists[Qa[iddists[0]],Qa[iddists[1]]]
                dgs = [len(conf_to_auth[ord_conf[q]]) for q in Q]
                stats = [thresdi, thresde, min(dgs), max(dgs), 1*(len(candidates)==0)]
                fqo.write( " ".join([str(conf_map[q][0]) for q in Q]) +"\t"+
                           " ".join(map(str, stats)) +"\t" +
                           " ".join(map(str, distsv)) +"\t" +
                           " ".join([str(conf_map[q][1]) for q in Q]) +"\n")

############## For the team formation, based on keywords
def prepareQKs(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    G = nx.read_edgelist(ff.replace(suff,".edges"), nodetype=int)
    lengthD = nx.all_pairs_shortest_path_length(G)
    lengthM = numpy.array([[lengthD[i][j] for j in range(len(G))] for i in range(len(G))])

    with open(ff.replace(suff, ".lcounts")) as fp:
    ## with open(ff.replace(suff, ".kwmap")) as fp:
        conf_names = [line.split()[0].strip() for line in fp]
                    
    conf_to_auth = {}
    with open(ff.replace(suff, ".kwedges")) as fp:
        for line in fp:
            parts = map(int,line.strip().split("\t"))
            if parts[0] in conf_to_auth:
                conf_to_auth[parts[0]].append(parts[1])
            else:
                conf_to_auth[parts[0]] = [parts[1]]
    offset = len(G)
    ord_conf = sorted([c for c in conf_to_auth.keys()])
    conf_map = dict([(i, (v, conf_names[v-offset])) for (i,v) in enumerate(ord_conf)])
    ca_dists = numpy.vstack([1+numpy.min(lengthM[conf_to_auth[conf], :], axis=0) for conf in ord_conf])
    cc_dists = numpy.zeros((ca_dists.shape[0], ca_dists.shape[0]), dtype=numpy.int8)
    for i in range(ca_dists.shape[0]):
        for j in range(i):
            cc_dists[i,j] = numpy.min(ca_dists[i,:]+ca_dists[j,:])
            cc_dists[j,i] = cc_dists[i,j]

    graceS = 2
    lmbd = 0.1
    seenQ = set()
    with open(ff.replace(suff, "-K.Qs"), "w") as fqo:
        for thresde, thresdi in [(0,0), (0,2), (5,0), (5,2)]:
	### thresde: min number of authors per conf
	### thresdi: max number of common authors between two confs in the query set
            for k in range(20):
                candidates = set([i for (i, v) in conf_map.items() if len(conf_to_auth[v[0]]) > thresde])
                samp = True
                Q = []
                while len(candidates) > 0 and numpy.random.random() >= (1-numpy.exp(-lmbd * (len(Q)-graceS))):
                    Q.append(numpy.random.choice(list(candidates)))
                    drop = numpy.where(cc_dists[Q[-1], :] <= thresdi)[0]
                    candidates.difference_update(drop)

                lq = len(Q)
                Q.sort()
                Qa = numpy.array(Q)
                iddists = numpy.where(numpy.tril(numpy.ones((lq,lq)),k=-1))

                distsv = cc_dists[Qa[iddists[0]],Qa[iddists[1]]]
                dgs = [len(conf_to_auth[ord_conf[q]]) for q in Q]
                stats = [thresdi, thresde, min(dgs), max(dgs), 1*(len(candidates)==0)]
                if len(Q) > 1 and tuple(Q) not in seenQ:
                    seenQ.add(tuple(Q))
                    fqo.write( " ".join([str(conf_map[q][0]) for q in Q]) +"\t"+
                               " ".join(map(str, stats)) +"\t" +
                               " ".join(map(str, distsv)) +"\t" +
                               " ".join([str(conf_map[q][1]) for q in Q]) +"\n")
    # pdb.set_trace()

def preparePapQKs(ff, data_parameters):
    suff = ".%s" % data_parameters.get("graph_ext", "edges")
    G = nx.read_edgelist(ff.replace(suff,".edges"), nodetype=int)
    off = len(G)

    lengthD = nx.all_pairs_shortest_path_length(G)
    lengthM = numpy.zeros((len(G)+1, len(G)), dtype=numpy.int8)
    for x, yvs in lengthD.items():
        ys, vs = zip(*yvs.items())
        lengthM[x,ys] = vs
    lengthM[-1,:] = float("inf")

    data = numpy.loadtxt(ff.replace(suff, ".kwedges"))
    mat_conf = numpy.array(sparse.coo_matrix((numpy.ones(data[:,0].shape), (data[:,1], data[:,0]-off)), dtype=numpy.bool, shape=(numpy.max(data[:,1])+2, numpy.max(data[:,0])-off+1)).todense())
    mat_conf[-1,:] = True
    ca_dists = numpy.vstack([1+numpy.min(lengthM[mat_conf[:,conf], :], axis=0) for conf in range(mat_conf.shape[1])])
    # pdb.set_trace()
    # CC = numpy.tile(ca_dists, (ca_dists.shape[1], 1, 1))
    # CB = CC.transpose((2,1,0))
    # cc_dists = numpy.min(CC+CB, axis=1)

    cc_dists = numpy.zeros((ca_dists.shape[0], ca_dists.shape[0]), dtype=numpy.int8)    
    for i in range(ca_dists.shape[0]):
        cc_dists[i,:] = numpy.min((numpy.tile(ca_dists[i,:], (ca_dists.shape[0], 1))+ ca_dists),axis=1)
        # for j in range(i):
        #     cc_dists[i,:] = numpy.min(ca_dists[i,:]+ca_dists[j,:])
        #     cc_dists[j,i] = cc_dists[i,j]
    print "Computed pairwise distances CC"
    with open(ff.replace(suff, ".kwmap")) as fp:
        conf_names = [line.strip() for line in fp]
    conf_map = dict([(v,k) for (k,v) in enumerate(conf_names)])
    
    Qns = []
    with open("../data/dblp/more/selected_papersKDD2_conf.txt") as fp:
        for line in fp:
            Qns.append([conf_map[k] for k in line.split("\t")[1].strip("\n").split(" ") if k in conf_map])

    with open(ff.replace(suff, "-P.Qs"), "w") as fqo:
        for Q in Qns:
            lq = len(Q)
            Q.sort()
            Qa = numpy.array(Q)
            iddists = numpy.where(numpy.tril(numpy.ones((lq,lq)),k=-1))

            distsv = cc_dists[Qa[iddists[0]],Qa[iddists[1]]]
            dgs = [mat_conf[:,q].sum() for q in Q]
            stats = [numpy.mean(distsv), numpy.max(distsv), min(dgs), max(dgs), len(Q)]
            if len(Q) > 1:
                fqo.write( " ".join([str(q+off) for q in Q]) +"\t"+
                           " ".join(map(str, stats)) +"\t" +
                           " ".join(map(str, distsv)) +"\t" +
                           " ".join([conf_names[q] for q in Q]) +"\n")
    # pdb.set_trace()

############## Recover from results summaries
def loadQs(fsumm):
    Qs = {}
    header = None
    with open(fsumm) as fq:
        for line in fq:
            if header is None:
                header = dict([(v,i) for (i,v) in enumerate(line.strip().split("\t"))])
            else:
                parts = line.strip().split("\t")
                Q = tuple(map(int, parts[header["qstr"]].split(":")[1].split("-")))
                if Q not in Qs:
                    tmp = int(parts[header["Qkey"]])
                    classes = (tmp/10, tmp%10, len(Qs))
                    Qs[Q] = classes
    return Qs

def recomputeQs(ff, data_parameters):

    fsumms = glob.glob(ff.replace(".edges", "-trunq_SCOu_*_summary.csv").replace("data/divers", "divers"))
    if len(fsumms) == 1:
        Qso = loadQs(fsumms[0])

    G = nx.read_edgelist(ff, nodetype=int)
    lengthD = nx.all_pairs_shortest_path_length(G)
    lengthM = numpy.array([[lengthD[i][j] for j in range(len(G))] for i in range(len(G))])

    with open(ff.replace(".edges", "-r7.Qs"), "w") as fqo:
        Qsk = sorted(Qso.keys(), key=lambda x: Qso[x][-1])
        for Q in Qsk:
            lq = len(Q)
            Qa = numpy.array(Q)
            iddists = numpy.where(numpy.tril(numpy.ones((lq,lq)),k=-1))
            # ll = lengthM[Q,:]
            # distsv = ll[:,Q]

            distsv = lengthM[Qa[iddists[0]],Qa[iddists[1]]]

            fqo.write( " ".join(map(str,Q)) +"\t"+
                       " ".join(map(str, Qso[Q][:2])) +"\t" +
                       " ".join(map(str, distsv)) +"\n")

    
ACTIONS = {##### Run main algorithm
           "trunq": runThroughQ,
           "trunc": runThroughCock,
           ##### Computing histograms
           "pass": doNothing,
           "hista": doHistsA,
           "histb": doHistsB,
           ##### Preparing data
           "svnum": saveAsNum,
           "svconf": prepareConfs,
           "svkw": prepareKeywords,
           ##### Preparing opinions
           "preor": prepareOpiR,
           "preof": prepareOpiF,
           ##### Preparing query sets
           "preqs": prepareQs,
           "preqc": prepareQCs,
           "preqk": prepareQKs,
           "preqa": preparePapQKs,
           ##### External functions
           "req": recomputeQs,
           "revala": revalTeamsQOW,
           "revalb": revalTeamsQ,
           "truns": runThroughS,
           "ego": extractSubs,
           "egol": extractSubsLocs,
           "filterl": filterGLocs,
           "bbox": filterGBBox,
           "team": chainTeam,
         }

    
################ MAIN    
def run(args):

    org_parameters = None
    if len(args) > 1:
        action = args[1]
        if len(args) > 2 and os.path.isfile(args[2]):
            fp = open(args[2])
            org_parameters = readParameters(fp)
            fp.close()
    if org_parameters is None:
        Warning("No parameters given")
        exit()

    data_parameters = dict(org_parameters)
    if not action in ACTIONS:
        print "Action %s does not exist..." % action
        exit()

    # series = [{}]
    bfs = []
    print "PARAMETERS:\n" + ("\n".join(["  * %s= %s" % (k,v) for (k,v) in data_parameters.items()]))
    #### Load data network from file
    if action not in ["ego", "egol"] and data_parameters.has_key("centers"):
        for centert in data_parameters["centers"].strip(" ;").split(";"):
            center = centert.strip()
            if data_parameters["min_weight"] is None:
                min_weight_s = ""
            else:
                min_weight_s = "-%.1f" % data_parameters["min_weight"]
            bname = "wegonet_%s%d%s" % (center.replace(" ",""), data_parameters["ego"], min_weight_s)
            bfs.append(("%s.%s" % (bname, data_parameters["graph_ext"]), center))

            # if "labels_ext" in data_parameters:
            #     bfs.append(("%s.%s" % (bname, data_parameters["graph_ext"]),
            #                 "%s.%s" % (bname, data_parameters["labels_ext"]),
            #                 center))
            # else:
            #     bfs.append(("%s.%s" % (bname, data_parameters["graph_ext"]),
            #                 "-",
            #                 center))
                            

    elif data_parameters.has_key('graph_file'):
        if "*" in data_parameters['graph_file']:
            starind = data_parameters['graph_file'].index("*")
            fnames = glob.glob(data_parameters['data_rep']+data_parameters['graph_file'])
            fnames.sort(key=lambda x: os.path.getsize(x))
            for gname in fnames:
                ser_b = gname[len(data_parameters['data_rep'])+starind:-len(data_parameters['graph_file'])+starind+1]
                lname = data_parameters.get('labels_file',"-").replace("*", ser_b)
                gname = gname[len(data_parameters['data_rep'])::]
                bfs.append((gname, lname, None))
        else:
            bfs.append((data_parameters['graph_file'], data_parameters.get('labels_file','-'), None))
    
    # if data_parameters.has_key('graph_file'):
    #     if "*" in data_parameters['graph_file']:
    #         starind = data_parameters['graph_file'].index("*")
    #         fnames = glob.glob(data_parameters['data_rep']+data_parameters['graph_file'])
    #         fnames.sort(key=lambda x: os.path.getsize(x))
    #         for gname in fnames:
    #             bfs.append((gname[len(data_parameters['data_rep'])::], None))
    #     else:
    #         bfs.append((data_parameters['graph_file'], None))

    # for center in data_parameters["centers"].split(";"):
    #     center = center.strip()
    #     cname = center.replace(" ", "")
    #     if len(cname) > 0:
    #         fnames = glob.glob(data_parameters['data_rep']+"wegonet_"+cname+"1-0.1.edges")
    #         if len(fnames) == 1:
    #             bfs.append((fnames[0][len(data_parameters['data_rep'])::], center))

    for bf, cent in bfs:
        data_parameters['basis'] = ".".join(bf.split(".")[:-1])
        data_parameters['network'] = ".".join(bf.split(".")[:-1])
        print "--------- %s -------" % data_parameters["basis"]
        cleanCache(data_parameters)
        if re.match("pr", action) or re.match("sv", action) or re.match("hist", action):

            graph = readGraph(data_parameters['data_rep']+ bf, center=cent, min_weight=data_parameters['min_weight'])
            graph = largestComponent(graph)
            print "Read graph [%d]..." % len(graph)

            trans_graph, map_iton, map_ntoi = translate_data(graph)
            data_parameters["graph"] = graph
            data_parameters["trans_graph"] = trans_graph
            data_parameters["map_iton"] = map_iton
            data_parameters["map_ntoi"] = map_ntoi
            data_parameters["data_file"] = data_parameters['data_rep']+ bf
            print "Translated..."

            nbo = data_parameters["nbo"]
            nopis = numpy.zeros((len(map_ntoi), nbo))
            data_parameters["oopityp"] = data_parameters["opityp"]
            data_parameters["nopis"] = nopis

            ## data_parameters["data_rep"] = data_parameters["results_rep"]
            if re.match("preo", action) or re.match("svnum", action) or re.match("hist", action): #### prepare opinions
                ACTIONS[action](trans_graph, nopis, data_parameters)
            else:
                ACTIONS[action](data_parameters['data_rep']+ bf, data_parameters)            
            continue

        ##### PREPARE THE NETWORK
        suff = ".%s" % data_parameters.get("graph_ext", "edges")
        graph = readGraphNum(data_parameters['data_rep']+ bf.replace(suff,".edges"))
        data_parameters['nb_auth'] = len(graph)
        print "Read graph [%d]..." % len(graph)
        
        ##### PREPARE THE OPINIONS
        nbo = data_parameters["nbo"]
        nopis = readOpisNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1]+["%s_opinions" % data_parameters['opityp']]))
        # nopis = readOpisNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1]+["%sopinions" % data_parameters['opityp']]))
        data_parameters['oopityp'] = data_parameters['opityp']
        print "Read opinions (%s)..." % data_parameters['oopityp']

        # ACTIONS["preo"](graph, nopis, data_parameters)
        # continue
        store_parameters = data_parameters
        store_utils = {}

        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
        fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
        G = nx.Graph(fad)
        # F = nx.Graph(adjG)
        # nx.draw_networkx(F, pos=nx.graphviz_layout(F))
        # plt.show()

        data_parameters["mats"] = (adjG, diaG, ccc)
        data_parameters["G"] = G
        data_parameters["totN"] = numpy.sum(diaG>0)
        data_parameters["totE"] = numpy.sum(adjG>0)/2.
        if nbo == "v":
            noavg_all_opds = {None: get_stats_opd(noavg_opd(nopis, adjG))}
        else:
            noavg_all_opds = [get_stats_opd(noavg_opd(nopis[:,[k]], adjG)) for k in range(nopis.shape[1])]

        ##### PREPARE THE QUERY SETS
        Qq = []
        Qdists = []
        if 0 in data_parameters["lqs"]:            
            Qqtmp, Qdiststmp = readQsNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1])+"-C.Qs")
            Qq.extend(Qqtmp)
            Qdists.extend(Qdiststmp)
            style = "C"
        else:
            for lq in data_parameters["lqs"]:
                Qqtmp, Qdiststmp = readQsNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1])+"-%d.Qs" % lq)
                Qq.extend(Qqtmp)
                Qdists.extend(Qdiststmp)
            style = "S"

        series = []
        data_parameters["extra_Qs"] = Qq
        data_parameters["extra_Qdists"] = Qdists
        for lqi, Q in enumerate(Qq):
            if nbo == "v":
                series.append({"Q": Q, "lqi": lqi, "Qkey": "".join(map(str,Qdists[lqi][0])), "lq": len(Q), "distTQ": sum(Qdists[lqi][1]), "distMQ": max(Qdists[lqi][1]), "opid": None})
            else:
                for opid in range(nbo):
                    series.append({"Q": Q, "lqi": lqi, "Qkey": "".join(map(str,Qdists[lqi][0])), "lq": len(Q), "distTQ": sum(Qdists[lqi][1]), "distMQ": max(Qdists[lqi][1]), "opid": opid})

        # series = [series[0]]
                    
        # data_parameters['gasis'] =  "%s%s-%s_%s%sO%s_%s_summary.csv" % (data_parameters['results_rep'], data_parameters['basis'], action, style, data_parameters["serie_suff"], data_parameters["oopityp"], datetime.datetime.now().strftime('%Y%m%d%H%M%S'))

        data_parameters['gasis'] =  "%s%s-%s_%s%sO%s_%s_summary.csv" % (data_parameters['results_rep'], data_parameters['basis'], action, style, data_parameters["serie_suff"], data_parameters["oopityp"], nbo)


        for serie in series:
            print "OPID", serie["opid"]
            data_parameters = dict(store_parameters)
            data_parameters["store_utils"] = store_utils
            data_parameters.update(serie)
            data_parameters['basis'] += "_%s%sO%so%s" % (style, data_parameters["serie_suff"], data_parameters["oopityp"], data_parameters["opid"])
            for field, v in noavg_all_opds[data_parameters["opid"]].items(): 
                data_parameters["all_"+field] = v

            if style == "C":                
                graph = readGraphNum((data_parameters['data_rep']+ bf).replace(".edges", ".confedges"), graph, serie["Q"])
                print "Read confs [%d]..." % len(graph)
            elif style == "K":
                graph = readGraphNum((data_parameters['data_rep']+ bf).replace(".edges", ".kwedges_more"), graph, serie["Q"])
                print "Read confs [%d]..." % len(graph)

            if data_parameters["opid"] is None:
                ACTIONS[action](graph, nopis, data_parameters)
            else:
                ACTIONS[action](graph, nopis[:, [data_parameters["opid"]]], data_parameters)

            if style in ["C", "K"]:
                cleanUpGraph(graph, serie["Q"])
        
                
if __name__ == "__main__":
    run(sys.argv)
