import random, itertools, math, copy, numpy, sys, datetime, csv
from experimental import *
import pdb

SCORE_METHS = {}
CHK_METHS = {}
CHU_METHS = {}

def getEdgesDistQ(Q, graph):
    dots, reached, paths = minConnect(graph, Q, {"meth": SCORE_METHS["e"], "data":{}})
    return [len(p) for p in paths]

def runThroughCock(graph, nopis, data_parameters):        
    list_parameters = [("qstr", "s", "---"), ("lq", "d", -1), ("lqi", "d", -1),
                       ("distTQ", "d", -1), ("distMQ", "d", -1), ("Qkey", "s", "---"), 
                       ("score", "s", "---"), ("method_name", "s", "---"),
                       ("network", "s", "---"), ("totN", "d", 0), ("totE", "d", 0),
                       ("serie_suff", "s", "---"), ("oopityp", "s", "---"), ("opid", "s", "---"), #("ownopiw", "f", -1),
                       ("all_opd_max", "f", -1), ("all_opd_mean", "f", -1), ("all_opd_median", "f", -1),
                       ("all_opd_tot", "f", -1), ("all_opd_var", "f", -1), ("all_opd_len", "f", -1),
                       ("external", "s", "---"), ("basis", "s", "---")]
    list_details = [("U", "f", -1), ("i", "f", -1), ("c", "f", -1), ("U_bckb", "f", -1),
                    ("opd_max", "f", -1), ("opd_mean", "f", -1), ("opd_median", "f", -1),
                    ("opd_tot", "f", -1), ("opd_var", "f", -1), ("opd_len", "f", -1),
                    ("nbN", "d", 0), ("nbE", "d", 0), ("rtime", "f", 0)]
    
    ### DISABLE GATHERING
    if not os.path.isfile(data_parameters['gasis']):
        fgather = openMakeP(data_parameters['gasis'], "w")
        str_prm = "\t".join([t[0] for t in list_parameters])
        str_det = "\t".join([t[0] for t in list_details])
        fgather.write(str_det + "\t" + str_prm + "\n")
    else:
        fgather = open(data_parameters['gasis'], "a+")

    data_parameters["score"] = "c"
    data_parameters["method_name"] = "findTeamCocktail"

    with open(data_parameters['gasis'].split("-trunc")[0]+"_out.txt") as fii:
        for line in fii:
            if len(line.strip("\n").split("\t")[1]) > 0:
                data_parameters["Q"] = map(type(graph.keys()[0]), line.strip("\n").split("\t")[0].split(" "))
                if data_parameters["Q"] in data_parameters["extra_Qs"]:
                    lqi = data_parameters["extra_Qs"].index(data_parameters["Q"])
                    print lqi, data_parameters["Q"]
                    data_parameters.update({"Q": data_parameters["Q"], "lqi": lqi,
                                            "Qkey": "".join(map(str, data_parameters["extra_Qdists"][lqi][0])),
                                            "lq": len(data_parameters["Q"]),
                                            "distTQ": sum(data_parameters["extra_Qdists"][lqi][1]),
                                            "distMQ": max(data_parameters["extra_Qdists"][lqi][1])})
                else:
                    pdb.set_trace()
                data_parameters["community"] = map(type(graph.keys()[1]), line.strip("\n").split("\t")[1].split(" "))
                data_parameters['qstr'] = "%d:%s" % (len(data_parameters['Q']), "-".join(map(str, data_parameters['Q'])))

                details, comm = findTeamCocktail(graph, nopis, data_parameters)

                str_prm = "\t".join([("%"+ t[1]) % data_parameters.get(t[0], t[-1]) for t in list_parameters])
                str_det = "\t".join([("%"+ t[1]) % details.get(t[0], t[-1]) for t in list_details])
                fgather.write(str_det + "\t" + str_prm + "\n")
                print str_det + "\t" + str_prm
            
    closeOut(fgather)


def findTeamCocktail(graph, nopis, data_parameters):
    #### Just get the best tree
    Q = data_parameters["Q"]
    scstr = data_parameters.get("score", "j")
    external = "tqcock-%s" %  scstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    # fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    dense = data_parameters["community"]

    details = logAndDetails(graph, nopis, dense, data_parameters, fo=None, more={"turn": 1})
    # closeOut(fo)
    # closeOut(fe)
    return details, dense


def runThroughQ(graph, nopis, data_parameters):        
    list_parameters = [("qstr", "s", "---"), ("lq", "d", -1), ("lqi", "d", -1),
                       ("distTQ", "d", -1), ("distMQ", "d", -1), ("Qkey", "s", "---"), 
                       ("score", "s", "---"), ("method_name", "s", "---"),
                       ("network", "s", "---"), ("totN", "d", 0), ("totE", "d", 0),
                       ("serie_suff", "s", "---"), ("oopityp", "s", "---"), ("opid", "s", "---"), #("ownopiw", "f", -1),
                       ("all_opd_max", "f", -1), ("all_opd_mean", "f", -1), ("all_opd_median", "f", -1),
                       ("all_opd_tot", "f", -1), ("all_opd_var", "f", -1), ("all_opd_len", "f", -1),
                       ("external", "s", "---"), ("basis", "s", "---")]
    list_details = [("U", "f", -1), ("i", "f", -1), ("c", "f", -1), ("U_bckb", "f", -1),
                    ("opd_max", "f", -1), ("opd_mean", "f", -1), ("opd_median", "f", -1),
                    ("opd_tot", "f", -1), ("opd_var", "f", -1), ("opd_len", "f", -1),
                    ("nbN", "d", 0), ("nbE", "d", 0), ("rtime", "f", 0)]
    data_parameters['qstr'] = "%d:%s" % (len(data_parameters['Q']), "-".join(map(str, data_parameters['Q'])))
    
    meths = []
    # for score in ["e"]: # SCORE_METHS.keys():
    #     meths.append( (findTeamQTree, {"score": score}))
    for score in ["e", "s"]: # SCORE_METHS.keys():
        meths.append( (findTeamQTree, {"score": score}))
    # for score in ["m", "s", "r"]: #"d", "m", "s", "r"]:
    #     meths.append( (findTeamQChk, {"score": score}))
    # for score in ["m", "s", "r"]: #"d", "m", "s", "r"]:
    #     meths.append( (findTeamQChk, {"score": score}))
    for score in ["s", "m", "r"]:
        meths.append( (findTeamQChk, {"score": score}))
    # for score in ["s"]: #"d", "m", "s", "r"]:
    #     # meths.append( (findTeamQCrf, {"score": score}))
    #     meths.append( (findTeamQBrf, {"score": score}))
    # for score in ["m", "s"]: #"d", "m", "s", "r"]:
    #     meths.append( (findTeamQChu, {"score": score}))

    ### DISABLE GATHERING
    if not os.path.isfile(data_parameters['gasis']):
        fgather = openMakeP(data_parameters['gasis'], "w")
        str_prm = "\t".join([t[0] for t in list_parameters])
        str_det = "\t".join([t[0] for t in list_details])
        fgather.write(str_det + "\t" + str_prm + "\n")
    else:
        fgather = open(data_parameters['gasis'], "a+")

    for mk, (meth, dtp) in enumerate(meths):
        data_parameters.update(dtp)
        data_parameters["method_name"] = meth.__name__

        details, comm = meth(graph, nopis, data_parameters)

        str_prm = "\t".join([("%"+ t[1]) % data_parameters.get(t[0], t[-1]) for t in list_parameters])
        str_det = "\t".join([("%"+ t[1]) % details.get(t[0], t[-1]) for t in list_details])
        fgather.write(str_det + "\t" + str_prm + "\n")
        print str_det + "\t" + str_prm

        for k in dtp.keys():
            del data_parameters[k]
        del data_parameters["method_name"]

    closeOut(fgather)


def findTeamQTree(graph, nopis, data_parameters):
    #### Just get the best tree
    Q = data_parameters["Q"]
    scstr = data_parameters.get("score", "j")
    score_meth = SCORE_METHS[scstr]
    external = "tqtree-%s" %  scstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    dense, paths = mainLoopQTree(graph, nopis, Q, score_meth, external, data_parameters)
    bckb = extractBackbone(paths, graph)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE, "turn": 1})

    if details is None:
        print "Second turn"
        newQ = list(set().union(*[graph[qq].keys() for qq in Q]).intersection(dense))
        new_graph = copy.deepcopy(graph)
        cleanUpGraph(new_graph, Q)
        dense, paths = mainLoopQTree(new_graph, nopis, newQ, score_meth, external, data_parameters)
        bckb = extractBackbone(paths, graph)
        details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE, "turn": 2})

    closeOut(fo)
    closeOut(fe)
    return details, dense


def mainLoopQTree(graph, nopis, Q, score_meth, external, data_parameters):
    curr_degrees = dict([(n, len(v)) for n,v in graph.items()])
    scoring = {"meth": score_meth, "data": {"degrees": curr_degrees, "nopis": nopis}}
    # scoring = {"meth": score_meth, "data": {"degrees": curr_degrees}}
    dots, reached, paths = minConnect(graph, Q, scoring)
    if dots is None:
        raise Warning("Tree could not connect!")

    # nd, reached = getShortMat(graph, Q, scoring)
    # paths_ep, kkd = getPathsTree(nd)
    # if kkd.min() != float("Inf"):
    #     raise Warning("Tree could not connect!")
    # paths = [extractPathReach(reached[Q[tni]], Q[fni]) for (tni,fni) in paths_ep]
    # dots = set().union(*paths)
    
    # paths_epP, kkdP = getPathsTreeP(nd)
    # if kkdP.min() != float("Inf"):
    #     raise Warning("Tree could not connect!")
    # pathsP = [extractPathReach(reached[Q[tni]], Q[fni]) for (tni,fni) in paths_epP]
    # dotsP = set().union(*pathsP)
    
    # print "ND", nd
    # print "Tree ", paths_ep, [nd[f,n] for (f,n) in paths_ep]
    # print "TreeP", paths_epP, [nd[f,n] for (f,n) in paths_epP]
    # if dots != dotsP:
    #     bckb = extractBackbone(paths, graph)
    #     dense = list(dots)
    #     details = logAndDetails(graph, nopis, dense, data_parameters, None, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE})

    #     bckbP = extractBackbone(pathsP, graph)
    #     denseP = list(dotsP)
    #     detailsP = logAndDetails(graph, nopis, denseP, data_parameters, None, more={"bckb": bckbP, "runtime": datetime.datetime.now() - ticE})
    #     pdb.set_trace()

    dense = list(dots)
    return dense, paths

def findTeamQChk(graph, nopis, data_parameters):
    #### Least tension with queries
    ####   top to bottom, with connectivity constraint
    Q = data_parameters["Q"]
    pickstr = data_parameters.get("score", "s")
    pick_meths = CHK_METHS[pickstr]
    score_meth = SCORE_METHS[pick_meths[-1]]
    print "SCORE", score_meth.__name__
    external = "tqck-%s" %  pickstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    dense, Qcore = mainLoopQChk(graph, nopis, Q, pick_meths, score_meth, external, data_parameters)
    
    bckb = extractBackbone(Qcore["paths"], graph)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE, "turn": 1})
    
    if details is None:
        print "Second Turn"
        newQ = list(set().union(*[graph[qq].keys() for qq in Q]).intersection(dense))
        new_graph = copy.deepcopy(graph)
        cleanUpGraph(new_graph, Q)
        dense, Qcore = mainLoopQChk(new_graph, nopis, newQ, pick_meths, score_meth, external, data_parameters)
        bckb = extractBackbone(Qcore["paths"], graph)
        details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE, "turn": 2})
        

    closeOut(fo)
    closeOut(fe)
    return details, dense



def mainLoopQChk(graph, nopis, Q, pick_meths, score_meth, external, data_parameters):
    if len(graph) > nopis.shape[0]:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items() if n < nopis.shape[0]])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "Q":Q, "nodes": curr_elems.keys()} #, "discount":0}
    else:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items()])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "nodes": curr_elems.keys()} #, "discount":0}

    sorted_nodes = SortedDict([((pick_meths[0](d),n), n) for n,d in curr_elems.items()])
    Qcore = getQCore(graph, Q, scoring)
    bckb = extractBackbone(Qcore["paths"], graph)
    nb_nodes = len(sorted_nodes)
    n = None

    #### for trace
    # if "mats" in data_parameters:
    #     gadj, gdia, gccc = data_parameters["mats"]
    # else:
    #     gadj, gdia, gccc = graph_to_mats(graph, None, None, data_parameters)
    # gccc = list(gccc)
    # fl = open("%s%s.%s_%s.trace" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['external'], data_parameters['qstr']), "w")
    # tmp = numpy.tile(nopis, (nopis.shape[0], 1))
    # diffs = numpy.abs(tmp-tmp.T)*(gadj>0)
    
    while len(sorted_nodes) > 0:
        (deg, n), _ = sorted_nodes.popitem()
        scoring["nodes"] = curr_elems.keys()
        # [3782, 3879, 1556, 1044, 1723]
        # if n in [256, 1216, 1922, 1411, 1350, 2508, 2028, 1782, 1879, 2457, 1210, 1151]:
        #     print n
        # elif n in [1963, 1469]:

        #     dotsW, reachedW, pathsW = minConnect(graph, Q, scoring=scoring, out=None, plog=True)
        #     dotsWo, reachedWo, pathsWo = minConnect(graph, Q, scoring=scoring, out=n, plog=True)
        #     pdb.set_trace()
        #### check whether can still connect
        ### if can still connect without, proceed removing, else keep aside
        if not disconnect(graph, n, Qcore, scoring):

            del curr_elems[n]
            # try:
            #     gccc.remove(n)
            # except ValueError:
            #     pdb.set_trace()
            # fl.write("%d %d %s %f\n" % (len(gccc), 0, n, numpy.sum(diffs[gccc,:][:,gccc])))
            reinsert = {}
            for neigh in set(graph[n].keys()).intersection(curr_elems.keys()):

                ov = pick_meths[0](curr_elems[neigh])
                outc = pick_meths[2](curr_elems, neigh, n)
                if outc or neigh in Qcore["core"]:
                    if (ov, neigh) in sorted_nodes:
                        nv = pick_meths[0](curr_elems[neigh])
                        if ov != nv:
                            sorted_nodes.pop((ov, neigh))
                            reinsert[(nv, neigh)] = neigh
                            
                else:
                    try:
                        sorted_nodes.pop((ov, neigh))
                        del curr_elems[neigh]
                        # gccc.remove(neigh)
                        # fl.write("%d %d %s %f\n" % (len(gccc), -1, neigh, numpy.sum(diffs[gccc,:][:,gccc])))
                    except KeyError:
                        if len(set(graph[neigh].keys()).intersection(Q)) < 2:
                            pdb.set_trace()
                            raise
            sorted_nodes.update(reinsert)
            aa = [ee for ee in reinsert.keys() if ee not in sorted_nodes.keys()]

            # if len(aa) > 0:
            #     gccc.extend(aa)
            #     fl.write("%d %d %s %f\n" % (len(gccc), +1, aa, numpy.sum(diffs[gccc,:][:,gccc])))

    # fl.close()                          
    #print "Discount:", scoring["discount"]
    dense = curr_elems.keys()
    #### HERE
    if len(graph) > nopis.shape[0]:
        dense.extend(Q)
    return dense, Qcore


def findTeamQTrc(graph, nopis, data_parameters):
    #### Least tension with queries
    ####   top to bottom, with connectivity constraint
    Q = data_parameters["Q"]
    pickstr = data_parameters.get("score", "s")
    pick_meths = CHK_METHS[pickstr]
    score_meth = SCORE_METHS[pick_meths[-1]]
    print "SCORE", score_meth.__name__
    external = "tqtc-%s" %  pickstr
    data_parameters["external"] = external
    data_parameters["from_meth"] = "tqck-%s" %  pickstr
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))
    dense, Qcore = mainLoopQTrc(graph, nopis, Q, pick_meths, score_meth, external, data_parameters)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE, "turn": 1})
    
    if details is None:
        print "Second Turn"
        newQ = list(set().union(*[graph[qq].keys() for qq in Q]).intersection(dense))
        new_graph = copy.deepcopy(graph)
        cleanUpGraph(new_graph, Q)
        dense, Qcore = mainLoopQTrc(new_graph, nopis, newQ, pick_meths, score_meth, external, data_parameters)
        details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE, "turn": 2})
        

    closeOut(fo)
    closeOut(fe)
    return details, dense


def mainLoopQTrc(graph, nopis, Q, pick_meths, score_meth, external, data_parameters):
    if len(graph) > nopis.shape[0]:
        curr_elems = [n for n in graph.keys() if n < nopis.shape[0]]
    else:
        curr_elems = graph.keys()

    if "mats" in data_parameters:
        gadj, gdia, gccc = data_parameters["mats"]
    else:
        gadj, gdia, gccc = graph_to_mats(graph, None, None, data_parameters)

    itzz = get_zzs_comm_iterate(gadj[:, curr_elems][curr_elems,:],
                                gdia[:, curr_elems][curr_elems,:], nopis[curr_elems],
                                data_parameters)
    old_elems = curr_elems
    old_zz = list(itzz)
    # ivzz = get_zzs_comm(gadj[:, curr_elems][curr_elems,:],
    #                             gdia[:, curr_elems][curr_elems,:], nopis[curr_elems],
    #                             data_parameters)
    # pdb.set_trace()

    Ui, Uc = part_tension(nopis[curr_elems], itzz, gadj[:, curr_elems][curr_elems,:],
                          gdia[:, curr_elems][curr_elems,:])
    U = Ui+Uc
    print "OVERALL TENSION", U
    count = 0
    with open("%s%s.%s_%s.trace" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['external'], data_parameters['qstr']), "w") as fo:
        filename = "%s%s.%s_%s.trace" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['from_meth'], data_parameters['qstr'])
        with open(filename, 'rb') as csvfile:
            spamreader = csv.reader(csvfile, delimiter=' ')
            for row in spamreader:
                lln, act, node, sten = int(row[0]), int(row[1]), int(row[2]), float(row[3])
                if act == 1:
                    curr_elems.append(node)
                    old_zz.append(nopis[node])
                elif act == 0 or act == -1:
                    idx = curr_elems.index(node)
                    curr_elems.pop(idx)
                    old_zz.pop(idx)
                count +=1

                if count % 25 == 0:
                    itzz = get_zzs_comm_iterate(gadj[:, curr_elems][curr_elems,:],
                                                gdia[:, curr_elems][curr_elems,:], nopis[curr_elems],
                                                data_parameters, numpy.array(old_zz))
                    Ui, Uc = part_tension(nopis[curr_elems], itzz, gadj[:, curr_elems][curr_elems,:],
                                          gdia[:, curr_elems][curr_elems,:])
                    old_zz = list(itzz)
                    U = Ui+Uc
                    # print " ".join(row + ["%f" % U])
                    fo.write(" ".join(row + ["%f" % U])+"\n")
                    count = 0
    #### HERE
    if len(graph) > nopis.shape[0]:
        curr_elems.extend(Q)
    return curr_elems, None


def findTeamQCrf(graph, nopis, data_parameters):
    #### Least tension with queries
    ####   top to bottom, with connectivity constraint
    Q = data_parameters["Q"]
    pickstr = data_parameters.get("score", "s")
    pick_meths = CHK_METHS[pickstr]
    score_meth = SCORE_METHS[pick_meths[-1]]
    print "SCORE", score_meth.__name__
    external = "tqcf-%s" %  pickstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))
    dense, best = mainLoopQCrf(graph, nopis, Q, pick_meths, score_meth, external, data_parameters)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE, "nb_eval": best["nb_eval"] })
            
    closeOut(fo)
    closeOut(fe)
    return details, dense


def findTeamQBrf(graph, nopis, data_parameters):
    #### Least tension with queries
    ####   top to bottom, with connectivity constraint
    Q = data_parameters["Q"]
    pickstr = data_parameters.get("score", "s")
    pick_meths = CHK_METHS[pickstr]
    score_meth = SCORE_METHS[pick_meths[-1]]
    print "SCORE", score_meth.__name__
    external = "tqbf-%s" %  pickstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))
    dense, best = mainLoopQBrf(graph, nopis, Q, pick_meths, score_meth, external, data_parameters)
    # dense, best = mainLoopQCrf(graph, nopis, Q, pick_meths, score_meth, external, data_parameters)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE, "nb_eval": best["nb_eval"] })
            
    closeOut(fo)
    closeOut(fe)
    return details, dense

def enumSubs(gadj, gdia, nopis, upd_opi, data_parameters, nodes, bv, i, best, Qcore=None, scoring=None, graph=None):
    for iv in [True, False]:
        bvl = bv.copy()
        bvl[i] = iv
        best["nb_eval"] +=1
        if iv or Qcore is None: 
            res, Qcc = (False, Qcore)
        else:
            res, Qcc = disconnectQC(graph, nodes[i], Qcore, scoring, nodes=nodes[bvl])
            # if not res:
            #     pdb.set_trace()

        if not res:
            if i == 0 and numpy.min(gadj[:, nodes[bvl]][nodes[bvl],:].sum(1)) > 0:
                # print "EVAL", [(int(bvl[nn]), node) for nn, node in enumerate(nodes)]
                # print "EVAL", [node for nn, node in enumerate(nodes) if bvl[nn]]
                ##### WARNING: THE MATRICES aren't scaled properly
                #####             for using the matrix inversion computation of opinions
                curr_idxs = nodes[bvl]
                itzz = get_zzs_comm_iterate(gadj[:, curr_idxs][curr_idxs,:],
                                            gdia[:, curr_idxs][curr_idxs,:], nopis[curr_idxs],
                                            data_parameters, upd_opi[curr_idxs])
                Ui, Uc = part_tension(nopis[curr_idxs], itzz, gadj[:, curr_idxs][curr_idxs,:],
                                      gdia[:, curr_idxs][curr_idxs,:])
                upd_opi[curr_idxs] = itzz
                U = Ui+Uc
                
                if U < best["U"] or (U == best["U"] and len(best["set"]) > len(nodes[bvl])):
                    best["U"] = U
                    best["found_it"] = best["nb_eval"]
                    best["set"] = set(nodes[bvl])
                    print "+", U, [node for nn, node in enumerate(nodes) if bvl[nn]]
            elif i > 0:
                enumSubs(gadj, gdia, nopis, upd_opi, data_parameters, nodes, bvl, i-1, best, Qcc, scoring, graph)
        # else:
        #     print "DIS", nodes[i], [(int(bvl[nn]), node) for nn, node in enumerate(nodes)]
                
def get_connected(graph, keepn, dropn, store=None):
    if store is None:
        store = []
    new_l = set().union(*[graph[k].keys() for k in keepn]).intersection(dropn)
    if len(new_l) > 0:
        kk = list(new_l)
        store += kk
        dd = list(new_l.symmetric_difference(dropn))
        return get_connected(graph, kk, dd, store)
    else:
        return store

def mainLoopQBrf(graph, nopis, Q, pick_meths, score_meth, external, data_parameters):
    if len(graph) > nopis.shape[0]:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items() if n < nopis.shape[0]])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "Q":Q, "nodes": curr_elems.keys()} #, "discount":0}
    else:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items()])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "nodes": curr_elems.keys()} #, "discount":0}

    sorted_nodes = SortedDict([((pick_meths[0](d),n), n) for n,d in curr_elems.items()])
    Qcore = getQCore(graph, Q, scoring)
    bckb = extractBackbone(Qcore["paths"], graph)

    keepn = bckb.keys()
    print "BACKBONE", keepn
    dd = sorted(set(curr_elems.keys()).difference(keepn))
    if "mats" in data_parameters:
        gadj, gdia, gccc = data_parameters["mats"]
    else:
        gadj, gdia, gccc = graph_to_mats(graph, None, None, data_parameters)

    best = {"U": float("Inf"), "found_it": -1, "nb_eval":0}
    upd_opi = nopis.copy()
    nodes = numpy.array(keepn+dd)
    # nodes = numpy.array([1, 3, 8, 9, 12, 13, 23]+keepn)
    print "# nodes= %d" % nodes.shape[0]
    bv = numpy.array([True for n in range(nodes.shape[0])])
    enumSubs(gadj, gdia, nopis, upd_opi, data_parameters, nodes, bv, bv.shape[0]-1, best, Qcore, scoring, graph)
    added = list(best["set"].symmetric_difference(Q))
    cadded = get_connected(graph, Q, added)
    # if len(cadded) < len(added):
    #     ddets = logAndDetails(graph, nopis, Q+added, data_parameters)
    part_sol = Q+cadded
    return part_sol, best


def mainLoopQCrf(graph, nopis, Q, pick_meths, score_meth, external, data_parameters):
    if len(graph) > nopis.shape[0]:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items() if n < nopis.shape[0]])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "Q":Q, "nodes": curr_elems.keys()} #, "discount":0}
    else:
        curr_elems = dict([(n, pick_meths[1](graph, nopis, n)) for n,v in graph.items()])
        scoring = {"meth": score_meth, "data": {"nopis": nopis}, "nodes": curr_elems.keys()} #, "discount":0}

    sorted_nodes = SortedDict([((pick_meths[0](d),n), n) for n,d in curr_elems.items()])
    Qcore = getQCore(graph, Q, scoring)
    bckb = extractBackbone(Qcore["paths"], graph)

    keepn = bckb.keys()
    print "BACKBONE", keepn
    dd = sorted(set(curr_elems.keys()).difference(keepn))
    if "mats" in data_parameters:
        gadj, gdia, gccc = data_parameters["mats"]
    else:
        gadj, gdia, gccc = graph_to_mats(graph, None, None, data_parameters)

    #### BASED ON BACKBONE 
    lk = numpy.min(nopis[keepn])
    uk = numpy.max(nopis[keepn])  
    ttt = [k for k in dd if (nopis[k] > lk and nopis[k] < uk)]
    dropn = get_connected(graph, keepn, [k for k in dd if (nopis[k] > lk and nopis[k] < uk)])
    print "KEEP %s, [%f, %f] %d/%d" % (keepn, lk, uk, len(dropn), len(dd)) 

    nodes = numpy.array(dropn+keepn)
    upd_opi = nopis.copy()
    best = {"U": float("Inf"), "found_it": -1, "nb_eval":0}
    bv = numpy.ones_like(nodes, dtype=bool)
    enumSubs(gadj, gdia, nopis, upd_opi, data_parameters, nodes, bv, len(dropn)-1, best)
    added = list(best["set"].symmetric_difference(keepn))
    cadded = get_connected(graph, keepn, added)
    # if len(cadded) < len(added):
    #     ddets = logAndDetails(graph, nopis, keepn+added, data_parameters)
    part_sol = keepn+cadded
    return part_sol, best
    


def findTeamQChu(graph, nopis, data_parameters):
    #### Least tension with queries
    ####   top to bottom, with connectivity constraint and updates along the way
    Q = data_parameters["Q"]
    pickstr = data_parameters.get("score", "s")
    pick_meth = CHU_METHS[pickstr][0]
    score_meth = SCORE_METHS[CHU_METHS[pickstr][-1]]
    # print "SCORE", score_meth.__name__
    external = "tqcu-%s" %  pickstr
    data_parameters["external"] = external
    print "------------METHOD=%s Q=%s" % (external, data_parameters["qstr"])

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, data_parameters["qstr"])
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    nodes = numpy.array(sorted(graph.keys()))
    candidates = nodes
    curr_degrees = dict([(n, len(v)) for n,v in graph.items()])
    # curr_degrees = dict([(n, len(graph[n])) for n in nodes])
    
    if "mats" in data_parameters:
        mat_adj, ccc = data_parameters["mats"]
    else:
        mat_adj, ccc = graph_to_mats(graph, nopis, None, data_parameters)
    mat_adj = mat_adj>0
    update_opis = get_zzs_comm_iterate(mat_adj, None, nopis, data_parameters)

    scoring = {"meth": score_meth, "data": {}, "nodes": nodes} #, "discount":0}
    Qcore = getQCore(graph, Q, scoring)
    bckb = extractBackbone(Qcore["paths"], graph)

    nb_nodes = len(nodes)
    n = None
    keep = []
    while len(candidates) > 0:
        cci = numpy.argmax([pick_meth(update_opis, cn, graph[cn].keys()) for cn in candidates])
        n = candidates[cci]
        candidates = numpy.delete(candidates, cci)
        scoring["nodes"] = nodes
        #### check whether can still connect
        ### if can still connect without, proceed removing, else keep aside
        if not disconnect(graph, n, Qcore, scoring):
            ndel = [numpy.where(nodes == n)[0][0]]
            cdel = []
            for neigh in set(graph[n].keys()).intersection(nodes):
                curr_degrees[neigh] -= 1
                if curr_degrees[neigh] == 0:
                    ndel.append(numpy.where(nodes == neigh)[0][0])
                    cdel.append(numpy.where(candidates == neigh)[0][0])

            nodes = numpy.delete(nodes, ndel)
            candidates = numpy.delete(candidates, cdel)

            next_opis = -numpy.ones_like(update_opis)
            mat_add = mat_adj[nodes, :]
            next_opis[nodes] = get_zzs_comm_iterate(mat_add[:, nodes], None, nopis[nodes], data_parameters, nzz=update_opis[nodes])
            update_opis = next_opis
    #print "Discount:", scoring["discount"]

    dense = list(nodes)

    bckb = extractBackbone(Qcore["paths"], graph)
    details = logAndDetails(graph, nopis, dense, data_parameters, fo, more={"bckb": bckb, "runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)
    return details, dense


def runReach(graph, q, scoring=None, out=None):
    reached = {q: (None, None)}
    newb = set([q])

    # subset = None
    # if curr_degrees is not None:
    #     subset = set(curr_degrees.keys())
    #     if n is not None:
    #         subset.discard(n)
    while len(newb) > 0:
        border = newb
        newb = set()
        for n in border:
            for neigh in graph[n].keys():
                # d = 1
                # if neigh not in reached[q] or reached[q][neigh][1] > reached[q][n][1] + d:
                if neigh == out or (scoring is not None and "nodes" in scoring and neigh not in scoring["nodes"]):
                    if "Q" in scoring and neigh in scoring["Q"] and q != neigh and ( neigh not in reached or reached[neigh][1] > reached[n][1] ):
                        reached[neigh] = (n, reached[n][1])
                    score = None
                elif scoring is not None: ## if a scoring function is provided, use it
                    
                    score = scoring["meth"](neigh, n, reached[n][1], scoring["data"])
                else: ## else, just nb of edges
                    score = 1+reached[n][1]
                if score is not None and ( neigh not in reached or reached[neigh][1] > score ):
                    newb.add(neigh)
                    # reached[q][neigh] = (n, reached[q][n][1]+d)
                    reached[neigh] = (n, score)
    return reached

def pathConnect(graph, Q, scoring=None, out=None):
    reached = runReach(graph, Q[1], scoring, out)
    return extractPathReach(reached, Q[0])

def getShortMat(graph, Q, scoring=None, out=None):
    reached = dict([(q, runReach(graph, q, scoring, out)) for q in Q])
    nd = numpy.array([[reached[q1].get(q2, (-1,-1))[1] for q1 in Q] for q2 in Q])
    nd[range(nd.shape[0]), range(nd.shape[1])] = 2*abs(nd.max())+1
    return nd, reached

def minConnect(graph, Q, scoring=None, out=None, plog=False, getPathsM=None):
    if getPathsM is None:
        getPathsM = getPathsTree
    nd, reached = getShortMat(graph, Q, scoring, out)
    paths_ep, kkd = getPathsM(nd)
    if kkd.min() != float("Inf"):
        # print "DISC", out
        # ppt = getAllPaths(reached, Q)
        return None, reached, None
    # paths = getPathsPiv(nd, reached, Q)
    paths = [extractPathReach(reached[Q[tni]], Q[fni]) for (tni,fni) in paths_ep]
    dots = set().union(*paths)
    return dots, reached, paths


def getAllPaths(reached, Q):
    paths = []
    for i in range(len(Q)):
        pq = Q[i]
        for j in range(i):
            if Q[j] in reached[pq]:
                nq = Q[j] 
                path = [nq]
                while reached[pq][nq][0] is not None:
                    nq = reached[pq][nq][0]
                    path.append(nq)
                paths.append(path)
    return paths


def getPathsPiv(nd, reached, Q):
    pqi = nd.sum(axis=1).argmin()
    pq = Q[pqi]
    paths = []
    for nq in Q:
        if pq != nq:
            path = [nq]
            while reached[pq][nq][0] is not None:
                nq = reached[pq][nq][0]
                path.append(nq)
            paths.append(path)
    return paths

def getPathsTree(nd):
    kkd = 1.0*nd
    off = kkd[0,0]
    kkd[numpy.tril(kkd+1)>0] = off
    kkd[kkd<0] = off

    subsets = {}
    mapsub = {}
    paths_ep = []
    #pdb.set_trace()
    while kkd.min() < off:
        fni, tni = numpy.unravel_index(kkd.argmin(), kkd.shape)
        if kkd[fni,tni] < off:
            if fni in mapsub and tni in mapsub:
                mergefrom = max(mapsub[fni], mapsub[tni])
                mergeto = min(mapsub[fni], mapsub[tni])
                for node in subsets[mergefrom]:
                    mapsub[node] = mergeto
                subsets[mergeto].extend(subsets[mergefrom])
                subsets[mergefrom] = None
            elif fni in mapsub and tni not in mapsub:
                mergeto = mapsub[fni]
                subsets[mergeto].append(tni)
                mapsub[tni] = mergeto
            elif fni not in mapsub and tni in mapsub:
                mergeto = mapsub[tni]
                subsets[mergeto].append(fni)
                mapsub[fni] = mergeto
            else: # fni not in mapsub and tni not in mapsub:
                mergeto = len(subsets)
                subsets[mergeto] = [fni, tni]
                mapsub[fni] = mergeto
                mapsub[tni] = mergeto


            for node in subsets[mergeto]:
                kkd[node, subsets[mergeto]] = float("Inf")
                
            #### get the path
            paths_ep.append((tni,fni))
    return paths_ep, kkd


def getPathsTreeP(nd):
    kkd = 1.0*nd
    off = kkd[0,0]
    kkd[numpy.tril(kkd+1)>0] = off
    kkd[kkd<0] = off

    subsets = {}
    mapsub = {}
    paths_ep = []
    while kkd.min() < off:
        tnds = kkd.argmin(axis=1)
        for fni, tni in list(enumerate(tnds)):
            if fni < tni and kkd[fni,tni] < off:

                if fni in mapsub and tni in mapsub:
                    mergefrom = max(mapsub[fni], mapsub[tni])
                    mergeto = min(mapsub[fni], mapsub[tni])
                    for node in subsets[mergefrom]:
                        mapsub[node] = mergeto
                    subsets[mergeto].extend(subsets[mergefrom])
                    subsets[mergefrom] = None
                elif fni in mapsub and tni not in mapsub:
                    mergeto = mapsub[fni]
                    subsets[mergeto].append(tni)
                    mapsub[tni] = mergeto
                elif fni not in mapsub and tni in mapsub:
                    mergeto = mapsub[tni]
                    subsets[mergeto].append(fni)
                    mapsub[fni] = mergeto
                else: # fni not in mapsub and tni not in mapsub:
                    mergeto = len(subsets)
                    subsets[mergeto] = [fni, tni]
                    mapsub[fni] = mergeto
                    mapsub[tni] = mergeto


                for node in subsets[mergeto]:
                    kkd[node, subsets[mergeto]] = float("Inf")
                
                #### get the path
                paths_ep.append((tni,fni))
        # if kkd.min() < off:
        #     pdb.set_trace()
    return paths_ep, kkd

def extractPathReach(reached, fn):
    path = []
    if fn in reached:
        nq = fn
        path = [fn]
        while reached[nq][0] is not None:
            nq = reached[nq][0]
            path.append(nq)
    return path

def getQCore(graph, Q, scoring=None):
    dots, reached, paths = minConnect(graph, Q, scoring)
    if dots is None or len(dots) == 0:
        pdb.set_trace()
        print "--- START UNCONNECTED..."
    return {"Q": Q, "core": dots, "reached": reached, "paths":paths}

# def repairConnect(graph, Qcore, n, curr_degrees):
#     dots, reached, pq, paths = minConnect(graph, Qcore["Q"], curr_degrees)
#     pdb.set_trace()
#     return 

def disconnect(graph, n, Qcore, scoring=None):
    if n not in Qcore["core"]:
        #if "discount" in scoring:
        #    scoring["discount"] +=1
        # print "--- %s not in" % n
        return False
    if n in Qcore["Q"]:
        # print "--- %s in Q" % n
        return True
    dots, reached, paths = minConnect(graph, Qcore["Q"], scoring, n)
    if dots is None:
        # print "::: No rewire %s" % n
        return True
    # print "::: Rewired %s" % n
    Qcore["core"] = dots
    Qcore["reached"] = reached
    Qcore["paths"] = paths
    return False

def disconnectQC(graph, n, Qcore, scoring=None, nodes=None):
    if n not in Qcore["core"]:
        #if "discount" in scoring:
        #    scoring["discount"] +=1
        # print "--- %s not in" % n
        return False, Qcore
    if n in Qcore["Q"]:
        # print "--- %s in Q" % n
        return True, None
    if nodes is not None:
        scoring["nodes"] = nodes
    dots, reached, paths = minConnect(graph, Qcore["Q"], scoring, n)
    if dots is None:
        # print "::: No rewire %s" % n
        return True, None
    # print "::: Rewired %s" % n
    Qcc = {"Q": Qcore["Q"],
           "core": dots,
           "reached": reached,
           "paths": paths}
    return False, Qcc


def extractBackbone(paths, graph):
    backbone = {}
    for path in paths:
        for i in range(len(path)-1):
            for (fn, tn) in [(path[i], path[i+1]), (path[i+1], path[i])]:
                if fn not in backbone:
                    backbone[fn] = {}
                backbone[fn][tn] = graph[fn][tn]
    return backbone


###################################################
#### SCORING FUNCTIONS
###################################################

# def scoreRnd(tn, fn, ant_score, data):
#     return ant_score + random.random()
# SCORE_METHS["r"] = scoreRnd

def scoreNbEdges(tn, fn, ant_score, data):
    if ant_score is None:
        ant_score = 0
    return ant_score + 1
SCORE_METHS["e"] = scoreNbEdges

def scoreMaxDegree(tn, fn, ant_score, data):
    if ant_score is None:
        ant_score = 0
    if tn in data.get("degrees", {}):
        return max(data["degrees"][tn], ant_score)
    return None
SCORE_METHS["d"] = scoreMaxDegree

def scoreJump(tn, fn, ant_score, data):
    if ant_score is None:
        ant_score = 0
    if "nopis" in data:
        if fn >= data["nopis"].shape[0] or tn >= data["nopis"].shape[0]:
            return ant_score
        else:
            return max(ant_score, numpy.abs(data["nopis"][fn] - data["nopis"][tn]).sum())
    return None
SCORE_METHS["j"] = scoreJump

def scoreSum(tn, fn, ant_score, data):
    if ant_score is None:
        ant_score = 0
    if "nopis" in data:
        if fn >= data["nopis"].shape[0] or tn >= data["nopis"].shape[0]:
            return ant_score
        else:
            return ant_score + numpy.abs(data["nopis"][fn] - data["nopis"][tn]).sum()
    return None
SCORE_METHS["s"] = scoreSum

def scoreSquare(tn, fn, ant_score, data):
    if ant_score is None:
        ant_score = 0
    if "nopis" in data:
        if fn >= data["nopis"].shape[0] or tn >= data["nopis"].shape[0]:
            return ant_score
        else:
            return ant_score + ((data["nopis"][fn] - data["nopis"][tn])**2).sum()
    return None
SCORE_METHS["S"] = scoreSquare

# def scoreFlips(tn, fn, ant_score, data):
#     if ant_score is None:
#         ant_score = (0,0)
#     if "nopis" in data:
#         return (0.001+ant_score[0] + 1.0 *(0>(ant_score[1]*(data["nopis"][fn] - data["nopis"][tn]))),
#                     data["nopis"][fn] - data["nopis"][tn])
#     return None
# SCORE_METHS["f"] = scoreFlips

# def scoreMono(tn, fn, ant_score, data):
#     if ant_score is None:
#         ant_score = (0, 0)
#     if "nopis" in data and numpy.sign(data["nopis"][fn] - data["nopis"][tn])*ant_score[1] >= 0:
#         return (abs(ant_score[1] + numpy.sign(data["nopis"][fn] - data["nopis"][tn])), ant_score[1] + numpy.sign(data["nopis"][fn] - data["nopis"][tn]))
#     return None 
# SCORE_METHS["m"] = scoreMono



###################################################
#### METHODS for the peeling "a la Charikar" algo
###################################################

#### get the score, from stored info, max amplitude of opinion around and including node
#### smaller better
def getScoreChuNodeOS(opis, n, neighs):
    return max([numpy.abs(opis[n]-opis[nv]).sum() for nv in neighs if opis.get(nv, -1) != -1])

#### get the score, from stored info, max amplitude of opinion around and including node
#### smaller better
def getScoreChuNodeSS(opis, n, neighs):
    return sum([numpy.abs(opis[n]-opis[nv]).sum() for nv in neighs if opis.get(nv, -1) != -1])

CHU_METHS["m"] = (getScoreChuNodeOS, "e")
CHU_METHS["s"] = (getScoreChuNodeSS, "e")


SELF = None

#### get the score, from stored info, max amplitude of opinion around and including node
#### smaller better
def getScoreChkNodeOS(vs):
    return numpy.max([numpy.abs(vs[SELF]-v).sum() for v in vs.values()])

#### get the score, from stored info, max amplitude of opinion around and including node
#### smaller better
def getScoreChkNodeSS(vs):
    return numpy.sum([numpy.abs(vs[SELF]-v).sum() for v in vs.values()])

# #### get the score, from stored info, max amplitude of opinion around and including node
# #### smaller better
# def getScoreChkNodeG(vs):
#     return abs(max(vs.values())-min(vs.values()))

#### prepare stored info, opinions of neighbors and node itself...
def elemScoreChkNodeG(graph, nopis, n, subset=None):
    if subset is not None:
        return dict([(SELF, nopis[n])] + [(neigh, nopis[neigh]) for neigh in subset.intersection(graph[n].keys()) if neigh < nopis.shape[0] ])
    return dict([(SELF, nopis[n])] + [(neigh, nopis[neigh]) for neigh in graph[n].keys() if neigh < nopis.shape[0] ])

#### update stored info of neighbor of latest drop, delete from neighbors...
def updateElemsChkNodeG(curr_elems, neigh, n):
    del curr_elems[neigh][n]
    return len(curr_elems[neigh]) > 1
CHK_METHS["m"] = (getScoreChkNodeOS, elemScoreChkNodeG, updateElemsChkNodeG, "e")
CHK_METHS["s"] = (getScoreChkNodeSS, elemScoreChkNodeG, updateElemsChkNodeG, "e")
#CHK_METHS["o"] = (getScoreChkNodeG, elemScoreChkNodeG, updateElemsChkNodeG, "e")

# #### get the score, from stored info, stored info is just the degree...
# #### smaller better
# def getScoreChkNodeD(vs):
#     return vs

# #### prepare stored info, just the degree...
# def elemScoreChkNodeD(graph, nopis, n, subset=None):
#     if subset is not None:
#         return len(subset.intersection(graph[n].keys()))
#     return len(graph[n])

# #### update stored info of neighbor of latest drop, i.e. decrease degree by one...
# def updateElemsChkNodeD(curr_elems, neigh, n):
#     curr_elems[neigh] -= 1
#     return curr_elems[neigh] > 0
# CHK_METHS["d"] = (getScoreChkNodeD, elemScoreChkNodeD, updateElemsChkNodeD, "d")


#### get the score, from stored info, stored info is just the degree...
#### smaller better
def getScoreChkNodeRnd(vs):
    return vs[0]

#### prepare stored info, just the degree...
def elemScoreChkNodeRnd(graph, nopis, n, subset=None):
    if subset is not None:
        return [random.random(), len(subset.intersection(graph[n].keys()))]
    return [random.random(), len(graph[n])]

#### update stored info of neighbor of latest drop, i.e. decrease degree by one...
def updateElemsChkNodeRnd(curr_elems, neigh, n):
    curr_elems[neigh][1] -= 1
    return curr_elems[neigh][1] > 0
CHK_METHS["r"] = (getScoreChkNodeRnd, elemScoreChkNodeRnd, updateElemsChkNodeRnd, "e")


