import random, itertools, math, copy, numpy, sys, datetime, csv
import networkx as nx
from experimental import *
import matplotlib.pyplot as plt
import pdb

## run the methods in a sequence for different sizes k and save results
def runThroughS(graph, nopis, data_parameters):
    for k in data_parameters["ks"]:
        data_parameters["k"] = k
        if k < len(graph):
            runThroughK(graph, nopis, data_parameters)

def runThroughK(graph, nopis, data_parameters):
    list_parameters = [("k", "d", -1), ("method_name", "s", "---"),
                       ("cap", "d", 0), ("exct", "d", 0), ("fiedler_typ", "s", "---"),
                       ("fiedler_thres", "f", 0), ("proj_dim", "d", 0),
                       ("network", "s", "---"), ("totN", "d", 0), ("totE", "d", 0),
                       ("serie_suff", "s", "---"), ("oopityp", "s", "---"), ("opid", "s", "---"),
                       ("external", "s", "---"), ("basis", "s", "---")]
    list_details = [("U", "f", -1), ("i", "f", -1), ("c", "f", -1), ("nbN", "d", 0), ("nbE", "d", 0), ("rtime", "f", 0)]


    meths = [(findTeamRand, {}),
             (findTeamRandW, {}),
             (findTeamGrel, {"cap": -100})]

    # meths = [(findTeamRand, {}),
    #          (findTeamRandW, {}),
    #          (findTeamGrel, {"cap": -100}),
    #          (findTeamGrel, {"exct": 1, "cap": -100}),
    #          (findTeamGrel, {"exct": 1, "cap": 500})]

    # for thres in ["greed"]+ list(numpy.arange(0, 1, 0.1)):
    #     for typ in ["exp_opi"]:
    #         meths.append( (findTeamFie, {"fiedler_typ":typ,"fiedler_thres": thres}))
    #         for nbdim in [2]:
    #             meths.append( (findTeamProj, {"fiedler_typ":typ,"fiedler_thres": thres, "proj_dim": nbdim}))


    # for thres in ["greed", 0] + list(numpy.arange(-0.1, -0.4, -0.1)):
    #     # for typ in ["edges", "adj", "lin_opi", "exp_opi"]:
    #     for typ in ["lin_opi"]:
    #         meths.append( (findTeamFie, {"fiedler_typ":typ,"fiedler_thres": thres}))
    #         for nbdim in [2, 4, 8]:
    #             meths.append( (findTeamProj, {"fiedler_typ":typ,"fiedler_thres": thres, "proj_dim": nbdim}))

    # adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
    # fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
    # G = nx.Graph(fad)

    # data_parameters["mats"] = (adjG, diaG, ccc)
    # data_parameters["G"] = G
    
    # fbasis = "%s%s_summary_%d.csv" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['k'])
    if not os.path.isfile(data_parameters['gasis']):
        fgather = openMakeP(data_parameters['gasis'], "w")
        str_prm = "\t".join([t[0] for t in list_parameters])
        str_det = "\t".join([t[0] for t in list_details])
        fgather.write(str_det + "\t" + str_prm + "\n")
    else:
        fgather = open(data_parameters['gasis'], "a+")

    for mk, (meth, dtp) in enumerate(meths):
        data_parameters.update(dtp)
        data_parameters["method_name"] = meth.__name__
        
        if data_parameters.get("fiedler_thres", 0) == "greed":
            data_parameters["fiedler_thres"] = data_parameters["greed_thres"]
        details, comm = meth(graph, nopis, data_parameters)

        if comm is not None and meth == findTeamGrel:
            data_parameters["greed_thres"] = details["highest_ediff"]

        str_prm = "\t".join([("%"+ t[1]) % data_parameters.get(t[0], t[-1]) for t in list_parameters])
        str_det = "\t".join([("%"+ t[1]) % details.get(t[0], t[-1]) for t in list_details])
        fgather.write(str_det + "\t" + str_prm + "\n")
        print str_det + "\t" + str_prm

        for k in dtp.keys():
            del data_parameters[k]
        del data_parameters["method_name"]

    closeOut(fgather)

## run the methods in a sequence and plot the results
def chainTeam(graph, nopis, data_parameters):
    meths = [("Rand", findTeamRand, {}),
             ("Grel-EI", findTeamGrel, {"exct": 1}),
             ("Proj-lin", findTeamProj, {"fiedler_typ":"lin_opi"}),
             ("Proj-lin3", findTeamProj, {"fiedler_typ":"lin_opi", "proj_dim":3}),
             ("Proj-lin5", findTeamProj, {"fiedler_typ":"lin_opi", "proj_dim":5}),
             ("Proj-lin10", findTeamProj, {"fiedler_typ":"lin_opi", "proj_dim":10})]

    meths = []

    for thres in numpy.arange(0, 1, 0.1):
        print thres
        if thres < 0.3:
            meths.append( ("Proj-lin%s" % thres, findTeamProj, {"fiedler_typ":"lin_opi","fiedler_thres": thres}))
            meths.append( ("Fiedler-lin%s" % thres, findTeamFie, {"fiedler_typ":"lin_opi","fiedler_thres": thres}))
            meths.append( ("Proj-exp%s" % thres, findTeamProj, {"fiedler_typ":"exp_opi","fiedler_thres": thres}))
            meths.append( ("Fiedler-exp%s" % thres, findTeamFie, {"fiedler_typ":"exp_opi","fiedler_thres": thres}))

    bigplot = True
    
    # data_parameters["stats"] = numpy.zeros((0,7))

    if bigplot:
        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
        fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
        G = nx.Graph(fad)

        data_parameters["mats"] = (adjG, diaG, ccc)
        data_parameters["G"] = G 

        if True: #"pos" not in data_parameters:
            pos = generate_positions(graph, adjG, nopis)        
            data_parameters["pos"] = pos
    
    for mk, (methid, meth, dtp) in enumerate(meths):
        data_parameters.update(dtp)
        if methid == "Fiedler-tex":
            data_parameters["fiedler_thres"] = data_parameters["greed_thres"]

        details, comm = meth(graph, nopis, data_parameters)
        if comm is not None:
            print methid, details["highest_ediff"], details["U"]
            if methid == "Grel-EI":
                data_parameters["greed_thres"] = details["highest_ediff"]
        for k in dtp.keys():
            del data_parameters[k]
        if comm is not None:
            plt.figure(1) #figsize=(20,15))
            plt.subplot(numpy.ceil(len(meths)/3.0), 3, mk+1)
            if bigplot:
                plot_comm_big(graph, nopis, details, comm, data_parameters, title_pre=methid)
            else:
                plot_comm(graph, nopis, details, comm, data_parameters, title_pre=methid)
    plt.tight_layout()
    
    if "stats" in data_parameters:
        store_stats = data_parameters["stats"]
        vnames = ["tops", "botts", "inn", "cross", "prox", "E", "mid"]
        cnames = ["tot", "bottops", "inn/tot", "E"]
        composite = numpy.vstack([store_stats[:,2]+store_stats[:,3], store_stats[:,0]+store_stats[:,1], store_stats[:,2]/(store_stats[:,2]+store_stats[:,3]), store_stats[:,5]]).T
        vrs = range(composite.shape[1])

        f, axarr = plt.subplots(len(vrs)-1, len(vrs)-1, num=2)
        for i in range(len(vrs)):
            for j in range(len(vrs)-1):
                if j < i:
                    axarr[i-1, j].scatter(composite[:,vrs[j]], composite[:,vrs[i]], marker="+")
                    axarr[i-1, j].set_xlabel(cnames[vrs[j]])
                    axarr[i-1, j].set_ylabel(cnames[vrs[i]])
                elif i > 0:
                    axarr[i-1, j].set_frame_on(False)
                    axarr[i-1, j].set_xticks([])
                    axarr[i-1, j].set_yticks([])
    plt.tight_layout()
    plt.show()

    # plt.savefig("%s%s_%d.png" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['k']))
    
def findTeamGroc(graph, nopis, data_parameters):
    #### Greedily add the neighbors of the node currently in the community
    ####   which is most similar in opinion to its neighbors
    k = data_parameters["k"]

    external = "tgroc"
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    top = (float("Inf"), None)

    opidiff_nds = getOpiDiffNodes(graph, nopis)
    srtnds = sorted(opidiff_nds.keys(), key=lambda x: -opidiff_nds[x])

    while len(srtnds) > 0:
        comm = [srtnds.pop()]
        new_nds = set(graph[comm[0]].keys())
        border = SortedDict([((-opidiff_nds[n],n), n) for n in new_nds])

        while len(comm)+len(new_nds) < k and len(border)> 0:
            comm.extend(new_nds)
            idx, nd = border.popitem()            
            new_nds = set(graph[nd].keys()).difference(comm)
            for n in new_nds:
                border[(-opidiff_nds[n],n)] = n

        if len(new_nds) > 0:
            comm.extend(sorted(new_nds, key=lambda x: opidiff_nds[n])[:k-len(comm)])

        if len(comm) == k:
            top = (-1, comm)
            srtnds = []
        else:
            comm.pop(0)
            i = 0
            while len(comm) > 0:
                if srtnds[i] in comm:
                    comm.remove(srtnds[i])
                    srtnds.pop(i)
                else:
                    i += 1
    
    details = logAndDetails(graph, nopis, comm, data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]

def findTeamGree(graph, nopis, data_parameters):
    #### ADD greedily nodes which are similar in opinion to their neighbors
    k = data_parameters["k"]

    cap = data_parameters.get("cap", 0)
    exct = data_parameters.get("exct", 0)

    external = "tgree-C%dE%d" % (cap, exct)
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    top = (float("Inf"), None, None)
    topoth = float("Inf")

    opidiff_nds = getOpiDiffNodes(graph, nopis)
    srtnds = sorted(opidiff_nds.keys(), key=lambda x: -opidiff_nds[x])
    cnt = 0
    while len(srtnds) > 0:
        comm = [srtnds.pop()]
        border = SortedDict([((-opidiff_nds[n],n), n) for n in graph[comm[0]].keys()])

        if cap < 0 and -cap > (len(graph)-len(srtnds)): ## stopping early
            srtnds = []

        while len(border) > 0 and len(comm) < k:
            idx, nd = border.popitem()
            comm.append(nd)
            for n in set(graph[nd].keys()).difference(comm):
                border[(-opidiff_nds[n],n)] = n

        if len(comm) == k:
            cnt += 1
            peaks = findPeaks(graph, nopis, nodeset=set(comm))
            if exct == 1:
                ss = nopis[comm]
                adj, dia, _ = graph_to_mats(graph, nopis, comm, data_parameters)
                zz = get_zzs_comm(adj, dia, ss, data_parameters)
                Ui, Uc = part_tension(ss, zz, adj, dia)
                U = Ui+Uc

                if "stats" in data_parameters:
                    sc = all_tension(ss, zz, adj, dia)
                    peaks = findPeaks(graph, nopis, nodeset=set(comm))
                    # points.append({"C": list(commc), "tops": len(peaks[0]), "botts": len(peaks[1]),
                    #                "inn": Ui, "cross": U, "prox": sc, "E": numpy.sum(adj>0)/2})
                    data_parameters["stats"] = numpy.vstack([data_parameters["stats"], [len(peaks[0]), len(peaks[1]),
                                                                           Ui, Uc, sc, numpy.sum(adj>0)/2, 1]])

                if U < top[0]:
                    top = (U, list(comm), cnt)
            else:
                sc = 0
                for node in comm:
                    sc += sum([(nopis[n]-nopis[node])**2 for n in graph[node].keys() if n in comm])

                if sc < top[0]:
                    top = (sc, list(comm), cnt)

        comm.pop(0)
        i = 0
        while len(comm) > 0 and i < len(srtnds):
            if srtnds[i] in comm:
                comm.remove(srtnds[i])
                srtnds.pop(i)
            else:
                i += 1

    details = logAndDetails(graph, nopis, top[1], data_parameters, fo, more={"runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]

def findTeamGrel(graph, nopis, data_parameters):
    #### ADD greedily nodes which increase least the tension within the community,
    k = data_parameters["k"]

    cap = data_parameters.get("cap", 0)
    if cap < 0:
        cap *= -k
    exct = data_parameters.get("exct", 0)
    prox = data_parameters.get("prox", "I")

    external = "tgrel-C%dE%dP%s" % (cap, exct, prox)
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    top = (float("Inf"), None, None)
    topoth = float("Inf")
    if prox == "M":
        popis = getOpiAvg(graph, nopis)
    else:
        popis = nopis
    opidiff_edges = getOpiDiffEdgesAvg(graph, nopis, popis)
    seen = set()
    cnt = 0

    while len(opidiff_edges) > 0:
        sc, nA, nB = opidiff_edges.pop(0)
        if cap > 0 and cnt > cap: #cap > 0 and cap*k*sc > top[0]:
        # if cap > 0 and cap*k*sc > top[0]:
            opidiff_edges = []
        if nA not in seen or nB not in seen:

            commc = [nA, nB]
            candidates = {}
            for (nF, nT) in [(nA, nB), (nB, nA)]: 
                for n in graph[nF].keys():
                    if n != nT:
                        candidates[n] = candidates.get(n, (nopis[n]-popis[n])**2) + (popis[n]-popis[nF])**2

            while len(commc) < k and len(candidates) > 0:
                minv, nxt = getKMinVal(candidates)
                sc += candidates[nxt]
                del candidates[nxt]
                commc.append(nxt)
                for n in graph[nxt].keys():
                    if n not in commc:
                        candidates[n] = candidates.get(n, (nopis[n]-popis[n])**2) + (popis[n]-popis[nxt])**2

            if len(commc) == k:
                cnt += 1
                if exct == 1:
                    ss = nopis[commc]
                    adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
                    zz = get_zzs_comm(adj, dia, ss, data_parameters)
                    Ui, Uc = part_tension(ss, zz, adj, dia)
                    U = Ui+Uc

                    peaks = findPeaks(graph, nopis, nodeset=set(commc))
                    if "stats" in data_parameters:
                        # points.append({"C": list(commc), "tops": len(peaks[0]), "botts": len(peaks[1]),
                        #                "inn": Ui, "cross": U, "prox": sc, "E": numpy.sum(adj>0)/2})
                        data_parameters["stats"] = numpy.vstack([data_parameters["stats"], [len(peaks[0]), len(peaks[1]),
                                                                               Ui, Uc, sc, numpy.sum(adj>0)/2, 2]])

                    # if U < top[0] or Ui < topoth:    
                    #     print ">>> %d\t%d\ti=%f c=%f u=%f\tnbe=%d\t%d+%d=%d" \
                    #           % (cnt, U< top[0], Ui, Uc, U, numpy.sum(adj>0)/2,
                    #              len(peaks[0]), len(peaks[1]), len(peaks[0])+ len(peaks[1]))
                    if U < top[0]:
                        top = (U, commc, cnt)

                    # if Ui < topoth:
                    #     topoth = Ui


                else:
                    if sc < top[0]:
                        top = (sc, commc, cnt)

            seen.update(commc)

    details = logAndDetails(graph, nopis, top[1], data_parameters, fo,
                            more={"cnb": top[-1], "ctot": cnt, "runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]


def findTeamGril(graph, nopis, data_parameters):
    #### FOCUS on inner tension
    k = data_parameters["k"]

    cap = data_parameters.get("cap", 0)
    exct = data_parameters.get("exct", 0)
    prox = data_parameters.get("prox", "I")

    external = "tgril-C%dE%dP%s" % (cap, exct, prox)
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    top = (float("Inf"), None, None)
    topoth = float("Inf")
    if prox == "M":
        popis = getOpiAvg(graph, nopis)
    else:
        popis = nopis
    opidiff_edges = getOpiDiffEdgesAvg(graph, nopis, popis)
    seen = set()
    cnt = 0

    while len(opidiff_edges) > 0:
        sc, nA, nB = opidiff_edges.pop(0)
        if cnt > 400: #cap > 0 and cap*k*sc > top[0]:
            opidiff_edges = []
        if nA not in seen or nB not in seen:

            commc = [nA, nB]
            candidates = {}
            for (nF, nT) in [(nA, nB), (nB, nA)]: 
                for n in graph[nF].keys():
                    if n != nT:
                        candidates[n] = candidates.get(n, (nopis[n]-popis[n])**2) + (popis[n]-popis[nF])**2

            while len(commc) < k and len(candidates) > 0:
                minv, nxt = getKMinValI(candidates, graph, nopis, commc)
                sc += candidates[nxt]
                del candidates[nxt]
                commc.append(nxt)
                for n in graph[nxt].keys():
                    if n not in commc:
                        candidates[n] = candidates.get(n, (nopis[n]-popis[n])**2) + (popis[n]-popis[nxt])**2

            if len(commc) == k:
                cnt += 1
                if exct == 1:
                    ss = nopis[commc]
                    adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
                    zz = get_zzs_comm(adj, dia, ss, data_parameters)
                    Ui, Uc = part_tension(ss, zz, adj, dia)
                    U = Ui+Uc

                    peaks = findPeaks(graph, nopis, nodeset=set(commc))
                    if "stats" in data_parameters:
                        # points.append({"C": list(commc), "tops": len(peaks[0]), "botts": len(peaks[1]),
                        #                "inn": Ui, "cross": U, "prox": sc, "E": numpy.sum(adj>0)/2})
                        data_parameters["stats"] = numpy.vstack([data_parameters["stats"], [len(peaks[0]), len(peaks[1]),
                                                                               Ui, Uc, sc, numpy.sum(adj>0)/2, 2]])

                    if Ui < top[0] or Ui < topoth:    
                        print ">>> %d\t%d\ti=%f c=%f u=%f\tnbe=%d\t%d+%d=%d" \
                              % (cnt, U< top[0], Ui, Uc, U, numpy.sum(adj>0)/2,
                                 len(peaks[0]), len(peaks[1]), len(peaks[0])+ len(peaks[1]))
                    if Ui < top[0]:
                        top = (Ui, commc, cnt)

                    if Ui < topoth:
                        topoth = Ui


                else:
                    if sc < top[0]:
                        top = (sc, commc, cnt)

            seen.update(commc)

    details = logAndDetails(graph, nopis, top[1], data_parameters, fo,
                            more={"cnb": top[-1], "ctot": cnt, "runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]


def findTeamLoc(graph, nopis, data_parameters):
    #### Evaluate all nodes with degree greater than k and their most similar neighbors
    k = data_parameters["k"]

    external = "tloc"
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    more = {}
    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()

    top = (float("Inf"), None, None)
    for nd, neighs in graph.items():
        if len(neighs) >= k-1:
            commc = [nd]+[nn[1] for nn in sorted([(abs(nopis[nd] - nopis[n]), n) for n in neighs])[:k-1]]
            ss = nopis[commc]
            adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
            zz = get_zzs_comm(adj, dia, ss, data_parameters)
            U = all_tension(ss, zz, adj, dia)
            if U < top[0] or U == top[0] and nd < top[-1]:
                top = (U, commc, nd)

    if top[-1] is not None:
        more["center"] = data_parameters["map_iton"][top[-1]]
    more["runtime"] = datetime.datetime.now() - ticE
    details = logAndDetails(graph, nopis, top[1], data_parameters, fo, more=more)
    closeOut(fo)
    closeOut(fe)

    return details, top[1]

def findTeamRandW(graph, nopis, data_parameters):
    #### Random walks with restarts to find the best team
    k = data_parameters["k"]
        
    external = "trwnd"
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    nb_restarts = 0
    max_restarts = 50
    max_steps = max(500, 20*k)
    max_steps = 50
    top = (float("Inf"), None)
    jumpp = 0.1
    
    while nb_restarts < max_restarts:

        nb_restarts += 1
        steps = 0
        init = random.choice(graph.keys())
        commc = set([init])
        current = init

        while len(commc) < k and steps < max_steps:
            candidates = graph[current].keys()
            if init in candidates:
                candidates.remove(init)
            if len(candidates) > 0 and numpy.random.random() > jumpp:
                dists = numpy.array([1/(nopis[n]-nopis[init]+0.001)**2 for n in candidates])
                sdists = sum(dists) #/(1.0-jumpp)
                dists = dists/sdists
                current = numpy.random.choice(candidates, p=dists)
            else:
                steps += 1
                current = init
            commc.add(current)
        # print "NB_RESTART:", nb_restarts, "\tNB_STEPS:", steps
        if len(commc) == k:
            comm = list(commc)
            ss = nopis[comm]
            adj, dia, _ = graph_to_mats(graph, nopis, comm, data_parameters)
            zz = get_zzs_comm(adj, dia, ss, data_parameters)
            Ui, Uc = part_tension(ss, zz, adj, dia)
            U = Ui+Uc
            if U < top[0]:
                # print "IMPROV:", U, top[0] 
                top = (U, comm)

    details = logAndDetails(graph, nopis, top[1], data_parameters, fo,
                            more={"runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]



def findTeamRand(graph, nopis, data_parameters):
    #### Just plain random
    k = data_parameters["k"]
        
    external = "trand"
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    nb_restarts = 0
    max_restarts = 10
    top = (float("Inf"), None)
    
    while nb_restarts < max_restarts:

        nb_restarts += 1
        init = random.choice(graph.keys())
        commc = [init]
        candidates = set(graph[init].keys())

        while len(commc) < k and len(candidates) > 0:
            nxt = candidates.pop()
            # nxt = random.choice(candidates)
            # candidates.remove(nxt)
            commc.append(nxt)
            candidates.update(set(graph[nxt].keys()).difference(commc))

            if len(commc) == k:
                ss = nopis[commc]
                adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
                zz = get_zzs_comm(adj, dia, ss, data_parameters)
                Ui, Uc = part_tension(ss, zz, adj, dia)
                U = Ui+Uc
                if U < top[0]:
                    top = (U, commc)

    details = logAndDetails(graph, nopis, top[1], data_parameters, fo,
                            more={"runtime": datetime.datetime.now() - ticE})
    closeOut(fo)
    closeOut(fe)

    return details, top[1]



def findTeamFie(graph, nopis, data_parameters):
    #### Use the Fiedler vector to order the nodes, then evaluate groups of adjacent nodes
    k = data_parameters["k"]

    thres = data_parameters.get("fiedler_thres", 0)
    typ = data_parameters.get("fiedler_typ", "nat")

    external = "tfie-%sT%s" % (typ, thres)
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    if "mats" in data_parameters:
        (adjG, diaG, ccc) = data_parameters["mats"]
    else:
        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)

    if "G" in data_parameters:
        G = data_parameters["G"]
    else:
        fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
        G = nx.Graph(fad)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    ordn = fiedler_order_all(adjG, nopis, thres=thres, typ=typ)

    # if opi == 2:
    #     # Qub = numpy.dot(numpy.linalg.inv(numpy.eye(adjG.shape[0])-adjG),diaG)
    #     thres = data_parameters.get("greed_thres", 0.1)
    #     ordn = fiedler_order_wei(graph, nopis, adjG, {}, thres)
    # elif opi == 1:
    #     ordn = fiedler_order_opi(graph, nopis, adjG)
    # else:
    #     ordn = fiedler_order(graph, adjG)

    top = (float("Inf"), None, None)
    cc, cb = (0,0)
    for sp in range(adjG.shape[0]-k):
        commc = list(ordn[sp:sp+k])
        H = G.subgraph(commc)
        if nx.number_connected_components(H) == 1:
            cc +=1
            ss = nopis[commc]
            adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
            zz = get_zzs_comm(adj, dia, ss, data_parameters)
            Ui, Uc = part_tension(ss, zz, adj, dia)
            U = Ui+Uc
            # print U, Ui, Uc
            if "stats" in data_parameters:
                sc = all_tension(ss, zz, adj, dia)
                peaks = findPeaks(graph, nopis, nodeset=set(commc))
                data_parameters["stats"] = numpy.vstack([data_parameters["stats"], [len(peaks[0]), len(peaks[1]),
                                                                       Ui, Uc, sc, numpy.sum(adj>0)/2, 3]])


            if U < top[0]:
                cb += 1
                top = (U, commc, sp)
    more = {"sp": top[-1], "runtime": datetime.datetime.now() - ticE, "connected": cc, "improved": cb}
    details = logAndDetails(graph, nopis, top[1], data_parameters, fo, more)
    closeOut(fo)
    closeOut(fe)

    return details, top[1]

def findTeamProj(graph, nopis, data_parameters):
    #### Apply a projection to the nodes, then evaluate groups of neighboring nodes
    k = data_parameters["k"]

    thres = data_parameters.get("fiedler_thres", 0)
    typ = data_parameters.get("fiedler_typ", "nat")
    nbdim = data_parameters.get("proj_dim", 2)

    external = "tproj-%sT%sD%d" % (typ, thres, nbdim)        
    data_parameters["external"] = external
    print "\n------------METHOD=%s k=%d" % (external, k)

    if "mats" in data_parameters:
        (adjG, diaG, ccc) = data_parameters["mats"]
    else:
        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)

    if "G" in data_parameters:
        G = data_parameters["G"]
    else:
        fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
        G = nx.Graph(fad)

    # fo = open("../test_tmp.txt", "w")
    fo, fe = initResOutSimple(data_parameters, external, k)
    ticE = datetime.datetime.now()
    ## comm = list(get_connected_k(graph, k))

    pmat = proj_mat(adjG, nopis, thres=thres, typ=typ, nbdim=nbdim)
    dists = scipy.spatial.distance.squareform(scipy.spatial.distance.pdist(pmat, metric='euclidean'))

    cc, cb = (0,0)
    top = (float("Inf"), None, None)
    for sp in range(adjG.shape[0]):
        commc = list(get_neighbors(sp, dists, k))
        H = G.subgraph(commc)
        if nx.number_connected_components(H) == 1:
            cc += 1
            ss = nopis[commc]
            adj, dia, _ = graph_to_mats(graph, nopis, commc, data_parameters)
            zz = get_zzs_comm(adj, dia, ss, data_parameters)
            Ui, Uc = part_tension(ss, zz, adj, dia)
            U = Ui+Uc
            # print U, Ui, Uc
            if "stats" in data_parameters:
                sc = all_tension(ss, zz, adj, dia)
                peaks = findPeaks(graph, nopis, nodeset=set(commc))
                data_parameters["stats"] = numpy.vstack([data_parameters["stats"], [len(peaks[0]), len(peaks[1]),
                                                                       Ui, Uc, sc, numpy.sum(adj>0)/2, 3]])


            if U < top[0]:
                cb += 1
                top = (U, commc, sp)

    more = {"sp": top[-1], "runtime": datetime.datetime.now() - ticE, "connected": cc, "improved": cb}
    details = logAndDetails(graph, nopis, top[1], data_parameters, fo, more)
    closeOut(fo)
    closeOut(fe)

    return details, top[1]

# def findTeamWalk(graph, nopis, data_parameters):
#     k = data_parameters["k"]
#     (adjG, diaG, ccc) = data_parameters["mats"]
#     pos = data_parameters["pos"]
#     G = data_parameters["G"]

#     external = "twalk"
#     print "\n------------METHOD=%s k=%d" % (external, k)

#     # fo = open("../test_tmp.txt", "w")
#     fo, fe = initResOutSimple(data_parameters, external, k)
#     ticE = datetime.datetime.now()
#     ## comm = list(get_connected_k(graph, k))

#     top = (float("Inf"), None)

#     nb_restarts = 0
#     nb_steps = 0
#     max_restarts = 10
#     max_steps = 10000

#     subgraphs = {}
#     node_to_sub = {}
#     SID = 0
    
#     edges = sorted(getOpiDiffEdges(graph, nopis))

#     while len(edges) > 0:
#         edge = edges.pop(0)
#         if edge[0] not in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[0]] = SID
#             node_to_sub[edge[1]] = SID 
#             subgraphs[SID] = set([edge[0], edge[1]])
#             SID += 1
#         if edge[0] not in node_to_sub and edge[1] in node_to_sub:
#             node_to_sub[edge[0]] = node_to_sub[edge[1]] 
#             subgraphs[node_to_sub[edge[1]]].add(edge[0])
#         if edge[0] in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[1]] = node_to_sub[edge[0]] 
#             subgraphs[node_to_sub[edge[0]]].add(edge[1])
#         else:
#             if len(subgraphs[node_to_sub[edge[1]]]) > len(subgraphs[node_to_sub[edge[0]]]):
#                 FID, TID = node_to_sub[edge[0]], node_to_sub[edge[1]]
#             else:
#                 FID, TID = node_to_sub[edge[1]], node_to_sub[edge[0]]
#             for node in subgraphs[FID]:
#                 node_to_sub[node] = TID
#             subgraphs[TID].update(subgraphs[FID])
#             del subgraphs[FID]


#     while nb_restarts < max_restarts:
#         nb_restarts += 1
#         nb_steps = 0
#         init = numpy.random.choice(graph.keys())
#         running_sum = nopis[init]
#         loc_chain = [init]
#         remember_chain = [(init, None, len(loc_chain), running_sum)]
#         while nb_steps < max_steps:
#             nb_steps += 1
#             cands = graph[loc_chain[-1]].keys()
#             prs = numpy.array([numpy.abs(running_sum/len(loc_chain) - nopis[n]) for n in cands])
#             nxt = numpy.random.choice(cands, p=prs/numpy.sum(prs))
#             if nxt in loc_chain:
#                 loc_chain.remove(nxt)
#                 loc_chain.append(nxt)
#             else:
#                 loc_chain.append(nxt)
#                 running_sum += nopis[nxt]
#                 drop = None
#                 if len(loc_chain) > k:
#                     drop = loc_chain.pop(0)
#                     running_sum -= nopis[drop]
#                 remember_chain.append((nxt, drop, len(loc_chain), running_sum))
#         pdb.set_trace()
    
#     details = logAndDetails(graph, nopis, comm, data_parameters, fo)
    
#     fo.write("Done in %s\n" % (datetime.datetime.now() - ticE))
#     closeOut(fo)
#     closeOut(fe)

#     return details, top[1]


# def findEdgesPull(graph, nopis, data_parameters):

#     opi = data_parameters.get("opi", 0)
        
#     external = "epull-O%d" % opi
#     data_parameters["external"] = external
#     print "\n------------METHOD=%s" % (external)

#     # fo = open("../test_tmp.txt", "w")
#     fo, fe = initResOutSimple(data_parameters, external, -1)
#     ticE = datetime.datetime.now()

#     selected_edges, non_edges, edges = kruskal(graph, nopis)
#     tree = wiggle_tree(graph, nopis, data_parameters, selected_edges, non_edges, edges)
#     adj, dia = edges_to_mats(graph, nopis, tree, data_parameters)
#     zz = get_zzs_comm(adj, dia, nopis, data_parameters)
#     Ui, Uc = part_tension(nopis, zz, adj, dia)
#     U = Ui+Uc
#     details = {"ss": nopis, "zz": zz, "tension": U, "inner": Ui, "cross": Uc}
#     return details, tree


# def findEdgesPulli(graph, nopis, data_parameters):

#     opi = data_parameters.get("opi", 0)
        
#     external = "epull-O%d" % opi
#     data_parameters["external"] = external
#     print "------------METHOD=%s\n" % (external)

#     # fo = open("../test_tmp.txt", "w")
#     fo, fe = initResOutSimple(data_parameters, external, -1)
#     ticE = datetime.datetime.now()

#     treeL, treeR = kruskal(graph, nopis, data_parameters, 0)
#     tree = treeL+treeR
#     adj, dia = edges_to_mats(graph, nopis, tree, data_parameters)
#     zz = get_zzs_comm(adj, dia, nopis, data_parameters)
#     Ui, Uc = part_tension(nopis, zz, adj, dia)
#     U = Ui+Uc

#     treeLi, treeRi = kruskal(graph, nopis, data_parameters, 1)
#     treei = treeLi+treeRi
#     adji, diai = edges_to_mats(graph, nopis, treei, data_parameters)
#     zzi = get_zzs_comm(adji, diai, nopis, data_parameters)
#     UUi, UUc = part_tension(nopis, zzi, adji, diai)
#     UU = UUi+UUc

#     print Uc-UUc, Ui-UUi
#     print "O", Ui, Uc, U, len(treeL), len(treeR)
#     print "I", UUi, UUc, UU, len(treeLi), len(treeRi)

#     if UUc > Uc:
#         print "REVERSED"
#         # pdb.set_trace()
        
#     details = {"ss": nopis, "zz": zz, "tension": U, "inner": Ui, "cross": Uc}
#     return details, tree


# def chainEdges(graph, nopis, data_parameters):
#     meths = [("Tree", findEdgesPull, {})]# ,
#              # ("Tree", findEdgesPull, {"opi": 1}),
#              # ("Tree", findEdgesPull, {"opi": -1})]

#     adjG, diaG, _ = graph_to_mats(graph, None, None, data_parameters)
#     fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
#     G = nx.Graph(fad)

#     dat_parameters["mats"] = (adjG, diaG)
#     data_parameters["G"] = G 

#     if "pos" not in data_parameters:
#         pos = generate_positions(graph, adjG)        
#         data_parameters["pos"] = pos


#     for mk, (methid, meth, dtp) in enumerate(meths):
#         data_parameters.update(dtp)
#         details, edges = meth(graph, nopis, data_parameters)
#         for k in dtp.keys():
#             del data_parameters[k]
#         if edges is not None:
#             plt.figure(1) #figsize=(20,15))
#             plt.subplot(numpy.ceil(len(meths)/3.0), 3, mk+1)
#             plot_edges_big(graph, nopis, details, edges, data_parameters, title_pre=methid)
#     plt.tight_layout()
    
#     plt.show()

#     # plt.savefig("%s%s_%d.png" % (data_parameters['results_rep'], data_parameters['basis'], data_parameters['k']))



# ###############################################################
# ########### TREE TOOLS KRUSKAL ALGORITHM

# def kruskal(graph, nopis):
#     edges = getOpiDiffEdgesL(graph, nopis)
#     edges.sort(reverse=True)
#     selected_edges, non_edges = sub_kruskal(len(graph), edges)
#     return selected_edges, non_edges, edges

# def sub_kruskal(N, edges):
#     subgraphs = {}
#     node_to_sub = {}
#     SID = 0
    
#     selected_edges = []
#     non_edges = []
#     while len(edges) > 0 and len(selected_edges) < N-1:
#         k = edges.pop()
#         edge = k[1:3]
#         if edge[0] not in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[0]] = SID
#             node_to_sub[edge[1]] = SID 
#             subgraphs[SID] = set([edge[0], edge[1]])
#             SID += 1
#             selected_edges.append(k)
#         elif edge[0] not in node_to_sub and edge[1] in node_to_sub:
#             node_to_sub[edge[0]] = node_to_sub[edge[1]] 
#             subgraphs[node_to_sub[edge[1]]].add(edge[0])
#             selected_edges.append(k)
#         elif edge[0] in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[1]] = node_to_sub[edge[0]] 
#             subgraphs[node_to_sub[edge[0]]].add(edge[1])
#             selected_edges.append(k)
#         elif node_to_sub[edge[1]] != node_to_sub[edge[0]]:
#             if len(subgraphs[node_to_sub[edge[1]]]) > len(subgraphs[node_to_sub[edge[0]]]):
#                 FID, TID = node_to_sub[edge[0]], node_to_sub[edge[1]]
#             else:
#                 FID, TID = node_to_sub[edge[1]], node_to_sub[edge[0]]
#             for node in subgraphs[FID]:
#                 node_to_sub[node] = TID
#             subgraphs[TID].update(subgraphs[FID])
#             del subgraphs[FID]
#             selected_edges.append(k)
#         elif non_edges is not None:
#             non_edges.append(k)
                        
#     return selected_edges, non_edges

# def wiggle_tree(graph, nopis, data_parameters, selected_edges, non_edges, edges):
#     tree_edges = [edge[1:3] for edge in selected_edges]
#     master = eval_edges(graph, nopis, tree_edges, data_parameters)
#     tree_graph, root = get_tree_graph(tree_edges, nopis)
#     layers = layer_tree(tree_graph, root)
#     cA, cB, cI = (0, 0, 0)
#     for sc, nA, nB in non_edges+edges:
#     # for sc, nA, nB in [(0.0, 65, 81)]:
#         sides = []
#         path = get_closing_path(tree_graph, root, layers, (nA, nB))
#         if len(path) == 3 and len(tree_graph[path[1]]) == 2:
#             pdb.set_trace()
#             nABod = nopis[nA]-nopis[nB]

#             drops = [(min(nA, path[1]), max(nA, path[1])),
#                      (min(nB, path[-2]), max(nB, path[-2]))]
#             nnA = [n for n in tree_graph[nA].keys() if n != path[1]]
#             nnAod = [nopis[nA]-nopis[n] for n in nnA]
#             exAod = nopis[nA]-nopis[path[1]]
#             if ( nABod * (nopis[nA]-nopis[path[1]]) < 0 and len(nnA) > 0):
#                 cA+=1
#                 if len([n for n in nnAod if n*exAod > 0]) == 0:
#                     sides.append(0)

#             nnB = [n for n in tree_graph[nB].keys() if n != path[-2]]
#             nnBod = [nopis[n]-nopis[nB] for n in nnB]
#             exBod = nopis[path[-2]]-nopis[nB]
#             if ( nABod * (nopis[path[-2]]-nopis[nB]) < 0 and len(nnB) > 0 ):
#                 cB+=1
#                 if len([n for n in nnBod if n*exBod > 0]) == 0:
#                     sides.append(1)

#             if len(sides) > 0:
#                 pdb.set_trace()
#                 if len(sides) == 1:
#                     did = sides[0]
#                 else:
#                     if abs(nopis[nA]-nopis[path[1]]) > abs(nopis[path[-2]]-nopis[nB]):
#                         did = 0
#                     else:
#                         did = 1

#             # if nopis[nA] < nopis[nB]:
#             #     nbdpA, frwdA, bkwdA = get_nbdp(tree_graph, (nA, nB), skip=[drops[0], (drops[0][1],drops[0][0])])
#             #     nbdpB, frwdB, bkwdB = get_nbdp(tree_graph, (nA, nB), skip=[drops[1], (drops[1][1],drops[1][0])])
#             # else:
#             #     nbdpA, frwdA, bkwdA = get_nbdp(tree_graph, (nB, nA), skip=[drops[0], (drops[0][1],drops[0][0])])
#             #     nbdpB, frwdB, bkwdB = get_nbdp(tree_graph, (nB, nA), skip=[drops[1], (drops[1][1],drops[1][0])])

#             # if nopis[nA] < nopis[path[1]]:
#             #     nbdpDA, frwdDA, bkwdDA = get_nbdp(tree_graph, (nA, path[1]))
#             # else:
#             #     nbdpDA, frwdDA, bkwdDA = get_nbdp(tree_graph, (path[1], nA))

#             # if nopis[nB] < nopis[path[-2]]:
#             #     nbdpDB, frwdDB, bkwdDB = get_nbdp(tree_graph, (nB, path[-2]))
#             # else:
#             #     nbdpDB, frwdDB, bkwdDB = get_nbdp(tree_graph, (path[-2], nB))

#             tte = list(tree_edges)
#             tte.remove(drops[did])
#             tte.append((nA, nB))
#             wig = eval_edges(graph, nopis, tte, data_parameters)
#             print "M vs W", [master[i] > wig[i] for i in range(len(master))], nA, nB, sides, did
#             print "M", master
#             print "W", wig
#             print nABod, path[1], nopis[nA]-nopis[path[1]], nnAod
#             print nABod, path[-2], nopis[path[-2]]-nopis[nB], nnBod
#             # print "pathes:", nbdpDA, frwdDA, bkwdDA,"\t", nbdpDB, frwdDB, bkwdDB
#             # print "pathes:", nbdpA, frwdA, bkwdA,"\t", nbdpB, frwdB, bkwdB
#             print "-------------------------"
#             # pdb.set_trace()
#             # if sum([master[i] > wig[i] for i in range(len(master))]) > 0:
#             #     pdb.set_trace()            
#         # 
#         # [nopis[path[i]]-nopis[path[i-1]] for i in range(len(path))]
#         # [nopis[path[i]] for i in range(len(path))]
#         ##### HERE
#     print cA, cB, cI
#     return tree_edges



# def get_nbdp(tree_graph, edge, skip=[]):
#     frwd = get_nbdp_frwd(tree_graph, edge, skip)
#     bkwd = get_nbdp_bkwd(tree_graph, edge, skip)
#     return frwd* bkwd, frwd, bkwd


# def get_nbdp(tree_graph, edge, skip=[]):
#     frwd = get_nbdp_frwd(tree_graph, edge, skip)
#     bkwd = get_nbdp_bkwd(tree_graph, edge, skip)
#     return frwd* bkwd, frwd, bkwd

# def get_nbdp_frwd(tree_graph, edge, skip):
#     ct = 1
#     for n,d in tree_graph[edge[1]].items():
#         if n != edge[0] and d and (edge[1], n) not in skip:
#           ct += get_nbdp_frwd(tree_graph, (edge[1], n), skip)
#     return ct

# def get_nbdp_bkwd(tree_graph, edge, skip):
#     ct = 1
#     for n,d in tree_graph[edge[0]].items():
#         if n != edge[1] and not d and (edge[1], n) not in skip:
#           ct += get_nbdp_bkwd(tree_graph, (n, edge[0]), skip)
#     return ct
 

# def get_tree_graph(tree_edges, nopis=None):
#     graph = {}
#     v = 1
#     max_d = (0,None)
#     for edge in tree_edges:
#         for side in [0,1]:
#             if nopis is not None:
#                 v = nopis[edge[side]] < nopis[edge[1-side]]

#             if edge[side] in graph:
#                 graph[edge[side]][edge[1-side]] = v
#                 if len(graph[edge[side]]) > max_d[0] or (len(graph[edge[side]]) == max_d[0] and edge[side] < max_d[1]):
#                     max_d = (len(graph[edge[side]]), edge[side])
#             else:
#                 graph[edge[side]]= {edge[1-side]: v}
#     return graph, max_d[1]

# def get_path_to_level(tree_graph, layers, path, level=0):
#     l, parent = min([(layers[n], n) for n in tree_graph[path[-1]].keys()])
#     path.append(parent)
#     if l > level:
#         get_path_to_level(tree_graph, layers, path, level)
                
# def get_closing_path(tree_graph, root, layers, edge):
#     paths = [[edge[0]], [edge[1]]]
#     if layers[edge[0]] < layers[edge[1]]:
#         get_path_to_level(tree_graph, layers, paths[1], level=layers[edge[0]])
#     elif layers[edge[0]] > layers[edge[1]]:
#         get_path_to_level(tree_graph, layers, paths[0], level=layers[edge[1]])

#     while paths[0][-1] != paths[1][-1]:
#         l, parent = min([(layers[n], n) for n in tree_graph[paths[0][-1]].keys()])
#         paths[0].append(parent)
#         l, parent = min([(layers[n], n) for n in tree_graph[paths[1][-1]].keys()])
#         paths[1].append(parent)

#     return paths[0][:-1]+paths[1][::-1]

# def layer_tree(tree_graph, root):
#     layers = {root: 0}
#     layer_tree_recurse(tree_graph, root, layers)
#     return layers

# def layer_tree_recurse(tree_graph, node, layers):
#     # if len([neigh for neigh in tree_graph[node].keys() if neigh in layers]) > 1:
#     #     pdb.set_trace()
#     for neigh in tree_graph[node].keys():
#         if neigh not in layers:
#             layers[neigh] = layers[node]+1
#             layer_tree_recurse(tree_graph, neigh, layers)


# def old_kruskal(graph, nopis, data_parameters, signed=0): ### MISSING PARTS
#     subgraphs = {}
#     node_to_sub = {}
#     SID = 0
#     selected_edges = []
    
#     if signed != 0:
#         sign_edges = SortedDict()
#         selected_edges_A, SID = old_sub_kruskal(graph, nopis, edges, subgraphs=subgraphs, node_to_sub=node_to_sub, SID=SID)
#         edges = sign_edges
    
#     selected_edges_A, SID = old_sub_kruskal(graph, nopis, edges, subgraphs=subgraphs, node_to_sub=node_to_sub, SID=SID)
#     return selected_edges, selected_edges_A

# def old_sub_kruskal(graph, nopis, edges, subgraphs=None, node_to_sub=None, SID = 0, sign_edges=None, signed=1):
#     if subgraphs is None:
#         subgraphs = {}
#     if node_to_sub is None:
#         node_to_sub = {}
    
#     selected_edges = []
#     # while len(edges) > 0 and len(selected_edges) < len(graph)-1:
#     while len(edges) > 0 and ( len(subgraphs) != 1 or len(subgraphs.values()[0]) < len(graph)):
#         k, v = edges.popitem()
#         edge = k[1:3]
#         new = []
#         if edge[0] not in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[0]] = SID
#             node_to_sub[edge[1]] = SID 
#             subgraphs[SID] = set([edge[0], edge[1]])
#             SID += 1
#             selected_edges.append(edge)
#             new = [0,1]
#         elif edge[0] not in node_to_sub and edge[1] in node_to_sub:
#             node_to_sub[edge[0]] = node_to_sub[edge[1]] 
#             subgraphs[node_to_sub[edge[1]]].add(edge[0])
#             selected_edges.append(edge)
#             new = [1]
#         elif edge[0] in node_to_sub and edge[1] not in node_to_sub:
#             node_to_sub[edge[1]] = node_to_sub[edge[0]] 
#             subgraphs[node_to_sub[edge[0]]].add(edge[1])
#             selected_edges.append(edge)
#             new = [0]
#         elif node_to_sub[edge[1]] != node_to_sub[edge[0]]:
#             if len(subgraphs[node_to_sub[edge[1]]]) > len(subgraphs[node_to_sub[edge[0]]]):
#                 FID, TID = node_to_sub[edge[0]], node_to_sub[edge[1]]
#             else:
#                 FID, TID = node_to_sub[edge[1]], node_to_sub[edge[0]]
#             for node in subgraphs[FID]:
#                 node_to_sub[node] = TID
#             subgraphs[TID].update(subgraphs[FID])
#             del subgraphs[FID]
#             selected_edges.append(edge)


#         if sign_edges is not None:
#             for ni in new:
#                 sign= (nopis[edge[ni]] - nopis[edge[1-ni]])
#                 for neigh in graph[edge[ni]].keys():
#                     if (nopis[edge[ni]] - nopis[neigh])*sign*signed > 0:
#                         if edge[ni] < neigh:
#                             k = (1-abs(nopis[edge[ni]]-nopis[neigh]), edge[ni], neigh)
#                         else:
#                             k = (1-abs(nopis[edge[ni]]-nopis[neigh]), neigh, edge[ni])
#                         try:
#                             v = edges.pop(k)
#                             sign_edges[k] = v
#                         except KeyError:
#                             pass
                        
#     return selected_edges, SID

