import pdb
import csv, glob, os.path
import numpy
import matplotlib.pyplot as plt

rep = "../xps/"
out_rep = "../xps_prepared/"
patts = [(rep+"author-author-wpapers.ICDM_all-trunq_SBOc_4_summary.csv", "ICDM"),
         (rep+"author-author-wpapers.ICDM_all-trunq_SBOc_v_summary.csv", "ICDM"),
         (rep+"wegonet_ChristosH.Papadimitriou2-0.3-trunq_SBOc_4_summary.csv", "C.Papadimitriou"),
         (rep+"wegonet_ChristosH.Papadimitriou2-0.3-trunq_SBOc_v_summary.csv", "C.Papadimitriou")]

OPERATORS = {"=": numpy.equal, "!=": numpy.not_equal, "<": numpy.less, "<=": numpy.less_equal, ">": numpy.greater, ">=": numpy.greater_equal}
OOPITYP = ["---", "l", "c", "ur", "cf", "kw", "t2r", "t4r", "t6r", "t8r", "x2r", "x4r", "x6r"]
SOL_PREF = ""


def getCompT(rest, A, fids, meth_to_id, score_to_id):
    dv = 1.
    idV = numpy.where(rest*(A[:,fids["method_name"]]==meth_to_id["findTeamQTree"])*(A[:,fids["score"]]==score_to_id["e"]))[0]
    if len(idV) == 1:
        dv = A[idV[0],fids["all_opd_mean"]]
    return dv

def getCompE(rest, A, fids, meth_to_id, score_to_id):
    dv = 1.
    idV = numpy.where(rest*(A[:,fids["method_name"]]==meth_to_id["findTeamQTree"])*(A[:,fids["score"]]==score_to_id["e"]))[0]
    if len(idV) == 1:
        dv = A[idV[0],fids["nbN"]]-1.
    return dv

def getCompUV(rest, A, fids, meth_to_id, score_to_id):
    dv = 1.
    idV = numpy.where(rest*(A[:,fids["method_name"]]==meth_to_id["findTeamQTree"])*(A[:,fids["score"]]==score_to_id["e"]))[0]
    if len(idV) == 1:
        dv = A[idV[0],fids["all_opd_mean"]]*(A[idV[0],fids["nbN"]]-1.)
    return dv


def draw_summary(filenames, title=""):
    which = None

    # seriesID = "lq"
    seriesID = "Qkey"
    # seriesID = "lqi"
    # shorts = ["Tr", "Ch"]
    # method_names = ["---", "findTeamQTree", "findTeamQChk"]
    shorts = ["Tr", "Ch", "Cu"]
    method_names = ["---", "findTeamQTree", "findTeamQChk", "findTeamQChu"]
    meth_to_id = dict([(v,i) for (i,v) in enumerate(method_names)])
    score_typs = ["---", "e", "s", "S", "j", "o", "m", "r", "d"]
    score_to_id = dict([(v,i) for (i,v) in enumerate(score_typs)])
    opid_to_id = dict([("%s" % i,i) for i in range(10)]+[('None', 0)])

    oopityp = OOPITYP #["---", "ur", "cf", "kw", "t2r", "t4r", "t6r", "t8r", "x2r", "x4r", "x6r"]
    oopityp_to_id = dict([(v,i) for (i,v) in enumerate(oopityp)])

    # which = ["Tr-e", "Tr-s", "Ch-m", "Ch-r", "Ch-s"]
    # for scr in score_typs[1:]:
    #     which.extend(["%s-%s" % (m,scr[:2]) for m in shorts])

    # variables = [(SOL_PREF+"opd_mean", "all_opd_mean", "findTeamQTree", "s"), ("nbE", "nbE", "findTeamQTree", "e"), (SOL_PREF+"opd_tot", SOL_PREF+"opd_tot", "findTeamQChk", "m"), ("U", "U", "findTeamQChk", "m")]
    variables = [(SOL_PREF+"opd_mean", getCompT), ("nbE", getCompE), (SOL_PREF+"opd_tot", getCompUV), ("U", getCompUV)]
    variables_plot = [("meanT", 0, None), ("nbE", 1, None), ("V", 2, None), ("U", 3, None)]

    # native_num = ["U","i","c","U_bckb","nbN","nbE","rtime","lq","lqi","opid", SOL_PREF+"opd_max", SOL_PREF+"opd_tot", SOL_PREF+"opd_mean", "all_opd_mean", "Qkey"]
    native_num = ["U","i","c","U_bckb","nbN","nbE","rtime","lq","lqi", SOL_PREF+"opd_max", SOL_PREF+"opd_tot", SOL_PREF+"opd_mean", "all_opd_mean", "Qkey"]
    native_nnum = [("score", score_to_id),
                   ("method_name", meth_to_id),
                   ("opid", opid_to_id),
                   ("oopityp", oopityp_to_id)]
    fids = dict([(v,i) for (i,v) in enumerate(native_num+[nnum[0] for nnum in native_nnum])])

    store = {}
    nb = len(filenames)
    for filename in filenames:
        with open(filename) as csvfile:
            reader = csv.DictReader(csvfile, delimiter='\t')
            # for row in reader:
            #     print row.keys()
            try:
                A = numpy.array([[float(row[field]) for field in native_num]+[nnum[1].get(row[nnum[0]],0) for nnum in native_nnum] for row in reader])
            except TypeError:
                A = None 

        if A is None or A.shape[0]*A.shape[1] == 0: # or A.shape[0] < 100:
            nb -= 1
            continue

        #### Q with seriesID Qkey
        A[:,fids[seriesID]] = numpy.mod(A[:,fids[seriesID]],10) + 10*A[:,fids["oopityp"]]
        # sercol = numpy.ones_like(A[:,fids[seriesID]]) #A[:,fids[seriesID]] #+ 10*A[:,fids["opid"]]
        sercol = A[:,fids[seriesID]] #+ 10*A[:,fids["opid"]]
        # sercol = 10*A[:,fids["opid"]]
        #### C all together...
        # sercol = 100*numpy.ones_like(A[:,fids[seriesID]]) #
        print filename, numpy.unique(sercol)
        
        #### UNUSED
        # A[:,fids[seriesID]] = numpy.floor(A[:,fids[seriesID]]/10.)
        # sercol = (numpy.mod(numpy.floor(A[:,fids[seriesID]]/20.),2)) + 10.*(A[:,fids["lq"]] > 5)
        # sercol = 1*(numpy.floor(A[:,fids[seriesID]]/20.) <2) + 10.*(A[:,fids["lq"]] > 5)
        # sercol = 6+ 10.*(A[:,fids["lq"]] > 5)
        series = []
        for m in method_names[1:]:
            for sct in numpy.unique(A[A[:,fids["method_name"]]==meth_to_id[m], fids["score"]]):
                series.append(("%s-%s" % (shorts[meth_to_id[m]-1], score_typs[int(sct)][:2]), m,
                               [{"op": "=", "what": "score", "val": sct},
                                # {"op": ">=", "what": "U", "val": 0}
                                ]))
        ks = numpy.unique(sercol)
        for k in ks:
            if k not in store:
                store[k] = {}
            accum = store[k]
            orest = sercol == k
            opids = numpy.unique(A[:,fids["opid"]])
            blocks = []
            for opid in opids:
                for lqi in numpy.unique(A[A[:,fids["opid"]]==opid, fids["lqi"]]):
                    blocks.append((opid, lqi))
            for opid, lqi in blocks:
                rest = orest*(A[:,fids["opid"]]==opid)*(A[:,fids["lqi"]]==lqi)

                VRand = 1.0
                var_fids = []
                denom = []
                for v, comp_meth in variables:
                    var_fids.append(fids[v])
                    dv = comp_meth(rest, A, fids, meth_to_id, score_to_id)
                    denom.append(dv)
                denom = numpy.array(denom)

                for mid, mname, othercs in series:
                    ncol = None
                    if which is None or mid in which:
                        idl = rest*(A[:,fids["method_name"]]==meth_to_id[mname])*(A[:,fids["U"]]>=0)
                        for otherc in othercs:
                            idl = idl*OPERATORS[otherc["op"]](A[:,fids[otherc["what"]]], otherc["val"])
                        if numpy.sum(idl) > 0:
                            ncol = A[idl,:][:,var_fids]
                            if mid not in accum:
                                accum[mid] = ncol/denom
                            else:
                                accum[mid] = numpy.vstack([accum[mid], ncol/denom])

    plotting_store(store, variables_plot, title, nb)
        
def plotting_store(store, variables, title="", nb=0):
    series = sorted(set([]).union(*[s.keys() for s in store.values()]))    
    ks = sorted(store.keys())
    # plt.show(block=False)
    for ki, k in enumerate(ks):
        data = store[k]
        varids = [v[1] for v in variables]
        for kki, kk in enumerate(series):
            opdist = OOPITYP[int(k/10.)]
            dtyp = k % 10
            fname = out_rep + "dataQ_%s(%s)_%s_%s.csv" % (title.replace(" ","."), opdist, dtyp, kk)
            if kk in data and data[kk].shape[0] > 1:
                numpy.savetxt(fname, data[kk][:,varids], delimiter='\t')

for patt, title in patts:
    if not os.path.isdir(out_rep):
        os.makedirs(out_rep)

    filenames = glob.glob(patt)
    # print "%% FILES:", filenames
    draw_summary(filenames, title)


