import csv, glob, re
import numpy
import pdb

##### COMPUTE THE RUNNNING TIME STATS AND PRODUCE TEX TABLE FOR REPORTING
rep = "../xps/"
patts.extend([(rep+"author-author-wpapers.ICDM_all-trunq_SBOc_4_summary.csv", "ICDM"),
              (rep+"author-author-wpapers.KDD_all-trunq_SBOc_4_summary.csv", "KDD"),
              (rep+"wegonet_ChristosH.Papadimitriou2-0.3-trunq_SBOc_4_summary.csv", "C.Papadimitriou"),
              (rep+"wegonet_ErikD.Demaine2-0.3-trunq_SBOc_4_summary.csv", "E.Demaine"),
              (rep+"wegonet_PhilipS.Yu2-0.3-trunq_SBOc_4_summary.csv", "P.Yu")])


OPERATORS = {"=": numpy.equal, "!=": numpy.not_equal, "<": numpy.less, "<=": numpy.less_equal, ">": numpy.greater, ">=": numpy.greater_equal}

SOL_PREF = ""

def draw_summary(filenames, title=""):
    which = None

    # seriesID = "lq"
    # seriesID = "Qkey"
    seriesID = "lqi"
    # shorts = ["Tr", "Ch"]
    # method_names = ["---", "findTeamQTree", "findTeamQChk"]
    # shorts = ["Tr", "Ch", "Cu"]
    shorts = ["\\algQTree", "\\algQPeel", "Cu"]
    simple = ["tree", "peel", "Cu"]
    method_names = ["---", "findTeamQTree", "findTeamQChk", "findTeamQChu"]
    meth_to_id = dict([(v,i) for (i,v) in enumerate(method_names)])
    score_typs = ["---", "e", "s", "S", "j", "o", "m", "r", "d"]
    score_to_id = dict([(v,i) for (i,v) in enumerate(score_typs)])
    ##opis_typs = ["---", "u", "l", "g"]
    opis_typs = ["---", "u", "l", "c", "g", "kw", "cf", "ur", "x6r", "t6r"]
    opis_to_id = dict([(v,i) for (i,v) in enumerate(opis_typs)])
    opis_to_id["cf"] = opis_to_id["kw"]
    opis_to_id["x6r"] = opis_to_id["ur"]
    opis_to_id["t6r"] = opis_to_id["ur"]
    score_to_id = dict([(v,i) for (i,v) in enumerate(score_typs)])
    ## opid_to_id = dict([("%s" % i,i) for i in range(10)]+[('None', 0)]) # ORG
    opid_to_id = dict([("%s" % i,1) for i in range(10)]+[('None', 0)])


    native_num = ["U","i","c","U_bckb","nbN","nbE","rtime","lq","lqi", SOL_PREF+"opd_max", SOL_PREF+"opd_tot", SOL_PREF+"opd_mean", "all_opd_mean", "totN", "totE", "distTQ", "distMQ"]
    native_nnum = [("score", score_to_id),
                   ("method_name", meth_to_id),
                   ("oopityp", opis_to_id),
                   ("opid", opid_to_id)]
    fids = dict([(v,i) for (i,v) in enumerate(native_num+[nnum[0] for nnum in native_nnum])])
    # names_sel = ["rtime", "totN", "totE", "distTQ", "distMQ", "Qkey"]
    # fids_sel = [fids[f] for f in names_sel]
    store = []
    nb = len(filenames)
    for filename in filenames:
        with open(filename) as csvfile:
            reader = csv.DictReader(csvfile, delimiter='\t')
            # for row in reader:
            #     print row.keys()
            try:
                A = numpy.array([[float(row[field]) for field in native_num]+[nnum[1].get(row[nnum[0]],0) for nnum in native_nnum] for row in reader])
            except TypeError:
                A = None

        if A is None or A.shape[0]*A.shape[1] == 0: # or A.shape[0] < 100:
            nb -= 1
            continue
        store.append(A)

    A = numpy.vstack(store)
    collect = []
    mids = []
    methds = [("findTeamQTree", "e" ), ("findTeamQTree", "s"), ("findTeamQChk", "s"), ("findTeamQChk", "m"), ("findTeamQChk", "r")]
    mids= [ "%s{(%s)}" % (shorts[meth_to_id[m]-1], sc) for m,sc in methds]
    midssimple = [ "%s%s" % (simple[meth_to_id[m]-1], sc) for m,sc in methds]
    sizes = numpy.unique(A[:,fids["totE"]]) #### ORG
    # sizes = numpy.unique(A[:,fids["opid"]])
    # sizes = [0] #[7701, 13250]
    oops = [4]
    oops = ["l",] # "kw"] #, "cf"] #,
    # oops = ["ur", "kw"] #, "cf"] #,
    for m,sc in methds:
        for te in sizes:
            for oop in oops:
                idx = (A[:,fids["method_name"]]==meth_to_id[m])*(A[:,fids["score"]]==score_to_id[sc]) # \
                idx *= (A[:,fids["totE"]] == te) #\ ### ORG
                ## idx *= (A[:,fids["opid"]] == te) #\
                ## idx *= (A[:,fids["lq"]] == oop)
                ## idx *= (A[:,fids["oopityp"]] == opis_to_id[oop])
                data = A[idx,:]
                tn = data[0,fids["totN"]]
                if data.shape[0] > 1:
                    collect.append((numpy.mean(data[:,fids["rtime"]]),
                                    numpy.std(data[:,fids["rtime"]]),
                                    data.shape[0],
                                    (m, sc, te, tn, oop)))
                else:
                    collect.append((-1,-1,0,(m, sc, te, tn, oop)))

    means = numpy.array([v[0] for v in collect]).reshape((len(mids),-1)).T
    stds = numpy.array([v[1] for v in collect]).reshape((len(mids),-1)).T

    stro = " ".join(["N", "E" ]+["%s_avg %s_std" % (mid, mid) for mid in midssimple]) + "\n"
    stro += " \n".join([" ".join(["%d" % collect[i][-1][3], "%d" % collect[i][-1][2]]+["%.4f %.4f" % (means[i,j], stds[i,j]) for j in range(means.shape[1])])     for i in range(means.shape[0])])

    print stro

filenames = []
for patt, title in patts:
    filenames.extend(glob.glob(patt))
print len(filenames)
draw_summary(filenames, title)







