#!/usr/bin/python
import numpy
import re, random, glob
import networkx as nx

from experimental import readParameters, cleanCache, readGraphNum, readOpisNum, graph_to_mats, get_stats_opd, noavg_opd, readQsNum, cleanUpGraph
from mine_team_Q import runThroughQ

import pdb


################ MAIN    
if __name__ == "__main__":

    action = "trunq"
    
    org_parameters = readParameters()
    org_parameters["results_rep"] = "../xps/"
    org_parameters["data_rep"] = "../data/"
    org_parameters["serie_suff"] = "B"
    data_parameters = dict(org_parameters)
    print "PARAMETERS:\n" + ("\n".join(["  * %s= %s" % (k,v) for (k,v) in data_parameters.items()]))

    bfs_bb = [
        # ("author-author-wpapers.KDD_all", 7, ("c")),
        ("author-author-wpapers.ICDM_all", 7, ("c")),
        ("wegonet_ChristosH.Papadimitriou2-0.3", 7, ("c")),
        # ("wegonet_PhilipS.Yu2-0.3", 0, ("c")),
        # ("wegonet_ErikD.Demaine2-0.3", 7, ("c")),
        # ("wegonet_PhilipS.Yu2-0.3", 7, ("c")),
        # ("coactC_Coppola", 4,  ("l", "n")),
        # ("coactC_Cameron", 4,  ("l", "n")),
        # ("coactD_WarnerBros197#", 4,  ("l", "n")),
        # ("coactB_WarnerBros200#", 4,  ("l", "n"))
	]

    bfs = []
    for bf, llqs, ttos in bfs_bb:
        for nnbo in (4, "v"):
            for tto in ttos:
                bfs.append((bf+".nedges", llqs, nnbo, tto))

    for bf, llqs, nnbo, tto in bfs:
        print ">>> ", bf, llqs, nnbo, tto
        data_parameters['basis'] = ".".join(bf.split(".")[:-1])
        data_parameters['network'] = ".".join(bf.split(".")[:-1])
        print "--------- %s -------" % data_parameters["basis"]
        data_parameters['opityp'] = tto
        data_parameters["nbo"] = nnbo
        data_parameters["lqs"] = [llqs]

        cleanCache(data_parameters)
        
        ##### PREPARE THE NETWORK
        graph = readGraphNum(data_parameters['data_rep']+ bf)
        data_parameters['nb_auth'] = len(graph)
        print "Read graph [%d]..." % len(graph)
        
        ##### PREPARE THE OPINIONS
        nbo = data_parameters["nbo"]
        nopis = readOpisNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1]+["%sopinions" % data_parameters['opityp']]))
        data_parameters['oopityp'] = data_parameters['opityp']
        print "Read opinions (%s)..." % data_parameters['oopityp']

        store_parameters = data_parameters
        store_utils = {}

        adjG, diaG, ccc = graph_to_mats(graph, None, None, data_parameters)
        fad = numpy.vstack([numpy.hstack([adjG, diaG]), numpy.hstack([numpy.zeros(adjG.shape), numpy.eye(adjG.shape[0])])])
        G = nx.Graph(fad)

        data_parameters["mats"] = (adjG, diaG, ccc)
        data_parameters["G"] = G
        data_parameters["totN"] = numpy.sum(diaG>0)
        data_parameters["totE"] = numpy.sum(adjG>0)/2.
        if nbo == "v":
            noavg_all_opds = {None: get_stats_opd(noavg_opd(nopis, adjG))}
        else:
            noavg_all_opds = [get_stats_opd(noavg_opd(nopis[:,[k]], adjG)) for k in range(nopis.shape[1])]

        ##### PREPARE THE QUERY SETS
        Qq = []
        Qdists = []
        if 0 in data_parameters["lqs"]:            
            Qqtmp, Qdiststmp = readQsNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1])+"-C.Qs")
            Qq.extend(Qqtmp)
            Qdists.extend(Qdiststmp)
            style = "C"
        else:
            for lq in data_parameters["lqs"]:
                Qqtmp, Qdiststmp = readQsNum(".".join((data_parameters['data_rep']+ bf).split(".")[:-1])+"-%d.Qs" % lq)
                Qq.extend(Qqtmp)
                Qdists.extend(Qdiststmp)
            style = "S"

        series = []
        data_parameters["extra_Qs"] = Qq
        data_parameters["extra_Qdists"] = Qdists
        for lqi, Q in enumerate(Qq):
            if nbo == "v":
                series.append({"Q": Q, "lqi": lqi, "Qkey": "".join(map(str,Qdists[lqi][0])), "lq": len(Q), "distTQ": sum(Qdists[lqi][1]), "distMQ": max(Qdists[lqi][1]), "opid": None})
            else:
                for opid in range(nbo):
                    series.append({"Q": Q, "lqi": lqi, "Qkey": "".join(map(str,Qdists[lqi][0])), "lq": len(Q), "distTQ": sum(Qdists[lqi][1]), "distMQ": max(Qdists[lqi][1]), "opid": opid})

        data_parameters['gasis'] =  "%s%s-%s_%s%sO%s_%s_summary.csv" % (data_parameters['results_rep'], data_parameters['basis'], action, style, data_parameters["serie_suff"], data_parameters["oopityp"], nbo)


        for serie in series:
            print "OPID", serie["opid"]
            data_parameters = dict(store_parameters)
            data_parameters["store_utils"] = store_utils
            data_parameters.update(serie)
            data_parameters['basis'] += "_%s%sO%so%s" % (style, data_parameters["serie_suff"], data_parameters["oopityp"], data_parameters["opid"])
            for field, v in noavg_all_opds[data_parameters["opid"]].items(): 
                data_parameters["all_"+field] = v

            if style == "C":                
                graph = readGraphNum((data_parameters['data_rep']+ bf).replace(".edges", ".confedges"), graph, serie["Q"])
                print "Read confs [%d]..." % len(graph)


            if data_parameters["opid"] is None:
                runThroughQ(graph, nopis, data_parameters)
            else:
                runThroughQ(graph, nopis[:, [data_parameters["opid"]]], data_parameters)

            if style in ["C"]:
                cleanUpGraph(graph, serie["Q"])
